//===========================//
//        Template.C         //
//   Template Example for   //
//  Windows_NT Applications  //
//===========================//

#include <windows.h>
#include "template.h"

#define  APP_MENU   "TemplateMenu"
#define  APP_ICON   "Template"

HANDLE hInst;
char   szAppTitle[] = "Application Template";
char   szAppName[]  = "Template";

//======================================================//
//   The AboutProc function requires no initialization  //
//  aside from what Windows NT supplies by default.    //
// AboutProc displays a simple text message, then exits //
// when the OK button is clicked.                       //
//======================================================//

BOOL FAR PASCAL AboutProc( HWND hDlg,   UINT msg,
                           UINT wParam, LONG lParam )
{
   switch (msg)
   {
      case WM_INITDIALOG:  return( TRUE );
      case WM_COMMAND:
         if( LOWORD( wParam ) == IDOK )
         {
            EndDialog( hDlg, TRUE );
            return( TRUE );
         }
         break;
   }
   return( FALSE );
   UNREFERENCED_PARAMETER( lParam );
}

UINT FAR PASCAL WndProc( HWND hWnd,   UINT msg,
                         UINT wParam, LONG lParam )
{
   FARPROC lpProc;

   switch( msg )
   {
      case WM_COMMAND:
         switch( LOWORD(wParam) )
         {
            case IDM_ABOUT:
               lpProc = MakeProcInstance(
                           (FARPROC) AboutProc, hInst );
               DialogBox( hInst, "AboutDlg",
                          hWnd,  lpProc );
               FreeProcInstance( lpProc );
               break;

            default:
               return( DefWindowProc( hWnd,   msg,
                                      wParam, lParam ) );
         }
         break;

      case WM_DESTROY:
         PostQuitMessage(0);
         break;

      default:
         return( DefWindowProc( hWnd,   msg,
                                wParam, lParam ) );
   }
   return( 0L );
}

//======================================================//
// The Template include file provides subroutines to    //
// initialize the application class and instance.       //
//======================================================//

#include "template.i"

//======================================================//
// WinMain provides the initial entry point for each    //
// application and, in turn, calls the application's    //
// initialization routines. If either initialization    //
// routine fails, WinMain returns FALSE                 //
//                                                      //
// Next, WinMain executes the loop to retrieve and      //
// dispatch messages, terminating when WM_QUIT is       //
// received (ie. GetMessage returns FALSE). This loop   //
// provides the top-level control structure for each    //
// application. When the loop terminates, WinMain       //
// returns the wParam argument from PostQuitMessage     //
//======================================================//

int WINAPI WinMain( HANDLE hInstance, HANDLE hPrevInstance,
             LPSTR  lpCmdLine, int    nCmdShow    )
{
   MSG   msg;

   if( ! hPrevInstance )
      if( ! InitApplication( hInstance ) )
         return( FALSE );
   if( ! InitInstance( hInstance, nCmdShow ) )
      return (FALSE);
   while( GetMessage( &msg, NULL, 0, 0 ) )
   {
      TranslateMessage( &msg );
      DispatchMessage( &msg );
   }
   return( msg.wParam );
   UNREFERENCED_PARAMETER( lpCmdLine );
}

