// PainText2View.cpp : implementation of the CPainText2View class
//

#include "stdafx.h"
#include "PainText2.h"

#include "PainText2Doc.h"
#include "PainText2View.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define NUM_LINES	99

/////////////////////////////////////////////////////////////////////////////
// CPainText2View

IMPLEMENT_DYNCREATE(CPainText2View, CScrollView)

BEGIN_MESSAGE_MAP(CPainText2View, CScrollView)
	//{{AFX_MSG_MAP(CPainText2View)
	ON_WM_SHOWWINDOW()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPainText2View construction/destruction

CPainText2View::CPainText2View()
{
	m_cxChr = 0;
	m_cyChr = 0;
}

CPainText2View::~CPainText2View()
{
}

BOOL CPainText2View::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CPainText2View drawing

void CPainText2View::OnDraw(CDC* pDC)
{
	CPainText2Doc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	CString		csText;
	int			i, x, y;
	TEXTMETRIC	tm;

	pDC->GetTextMetrics( &tm );
	m_cyChr = tm.tmHeight;
	m_cxChr = tm.tmAveCharWidth;
	pDC->SetTextAlign( TA_LEFT | TA_TOP );
	for( i=0; i<=NUM_LINES; i++ )
	{
		x = 1 + m_cxChr * i;
		y = 1 + m_cyChr * i;
		csText.Format( "This is line %d being displayed at X:%d / Y:%d",
	                   i, x, y );
		pDC->TextOut( x, y, csText );
	}
}

/////////////////////////////////////////////////////////////////////////////
// CPainText2View printing

BOOL CPainText2View::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CPainText2View::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CPainText2View::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CPainText2View diagnostics

#ifdef _DEBUG
void CPainText2View::AssertValid() const
{
	CView::AssertValid();
}

void CPainText2View::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CPainText2Doc* CPainText2View::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CPainText2Doc)));
	return (CPainText2Doc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CPainText2View message handlers

void CPainText2View::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	if( m_cxChr > 0 && m_cyChr > 0 )
		SetScrollSizes( MM_TEXT, CSize( m_cxChr*100, m_cyChr*100),
						CSize(m_cxChr*10, m_cyChr*10), CSize(m_cxChr, m_cyChr) );
	else
		SetScrollSizes( MM_TEXT, CSize( 1300, 2000), CSize(130,200), CSize(13,20) );
}

void CPainText2View::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CScrollView::OnShowWindow(bShow, nStatus);
	
	// TODO: Add your message handler code here
	if( bShow )
	{
		TEXTMETRIC	tm;
		CDC			*pDC;

		pDC = GetDC();
		pDC->GetTextMetrics( &tm );
		m_cyChr = tm.tmHeight + tm.tmExternalLeading;
		m_cxChr = tm.tmMaxCharWidth;
	}
}
