//==========================//
//         Mouse1.C         //
//  Windows Mouse Tracking  //
//==========================//

#include <windows.h>

#define APP_MENU  NULL
// note: no icon or cursor assignments

HANDLE hInst;
char   szAppTitle[] = "Mouse1: Tracking Demo";
char   szAppName[]  = "Mouse1";

long APIENTRY WndProc( HWND hwnd,   UINT msg,
                         UINT wParam, LONG lParam )
{
   HDC          hdc;
   PAINTSTRUCT  ps;
   static BOOL  fPaint = 0;

   switch( msg )
   {
      case WM_MOUSEMOVE:
         if( fPaint )
         {
            hdc = GetDC( hwnd );
            SetPixel( hdc, LOWORD( lParam ),
                      HIWORD( lParam ), 0L );
            ReleaseDC( hwnd, hdc );
         }
         break;

      case WM_LBUTTONDOWN:
         fPaint = fPaint ^ 1;
         MessageBeep(0);
         break;

      case WM_PAINT:
         hdc = BeginPaint( hwnd, &ps );
         EndPaint( hwnd, &ps );
         break;

      case WM_DESTROY:
         PostQuitMessage(0);
         break;

      default:
         return( DefWindowProc( hwnd,   msg,
                                wParam, lParam ) );
   }
   return 0;
}

#include "template.i"

int APIENTRY WinMain( HANDLE hInstance, HANDLE hPrevInstance,
                      LPSTR  lpCmdLine, int    nCmdShow    )
{
   MSG   msg;

   if( ! hPrevInstance )
      if( ! InitApplication( hInstance ) )
         return( FALSE );
   if( ! InitInstance( hInstance, nCmdShow ) )
      return (FALSE);
   while( GetMessage( &msg, NULL, 0, 0 ) )
   {
      TranslateMessage( &msg );
      DispatchMessage( &msg );
   }
   return( msg.wParam );
   UNREFERENCED_PARAMETER( lpCmdLine );
}

