//======================//
//       Mouse2.C       //
//  Windows Mouse Test  //
//======================//

#include <windows.h>

#define APP_MENU  NULL
// note: no icon or cursor assignments

HANDLE  hInst;
char    szChildClass[] = "Mouse2_Child";
char    szAppTitle[]   = "Mouse2: Stock Cursors";
char    szAppName[]    = "Mouse2";
BOOL    Visible        = TRUE;
HWND	hwndChild[7][2];
char	szArrowName[7][2][11] = 
		{	"Starting", 	"SizeAll",
			"Standard",		"Size NE/SW",
			"Cross",		"Size N/S",
			"I-Beam",		"Size NW/SE",
			"<<Icon>>",		"Size E/W",
			"Negative",		"<<Size>>",
			"Wait",			"UpArrow"   };

long APIENTRY ChildWndProc( HWND hwnd,   UINT msg,
                            UINT wParam, LONG lParam  )
{
	HDC          hdc;
	PAINTSTRUCT  ps;
	RECT         rect;

	switch( msg )
	{
		case WM_MOUSEMOVE:
			if( ! Visible ) ShowCursor( TRUE );
			Visible = TRUE;
			switch( GetWindowLong( hwnd, GWL_ID ) )
			{
				case 0x0000:
					SetCursor( LoadCursor( NULL, IDC_APPSTARTING ) );
					break;
				case 0x0001:
					SetCursor( LoadCursor( NULL, IDC_ARROW ) );
					break;
				case 0x0002:
					SetCursor( LoadCursor( NULL, IDC_CROSS ) );
					break;
				case 0x0003:
					SetCursor( LoadCursor( NULL, IDC_IBEAM ) );
					break;
				case 0x0004:
					SetCursor( LoadCursor( NULL, IDC_ICON ) );
					break;
				case 0x0005:
					SetCursor( LoadCursor( NULL, IDC_NO ) );
					break;
				case 0x0006:
					SetCursor( LoadCursor( NULL, IDC_WAIT ) );
					break;
/*
  1  IDC_APPSTARTING	Standard arrow and small hourglass
  2  IDC_ARROW			Standard arrow
  3  IDC_CROSS			Crosshair
  4  IDC_IBEAM			Text I-beam
  5  IDC_ICON			not supported under Windows 98 
  6  IDC_NO				Slashed circle
  7  IDC_WAIT			Hourglass
*/
				case 0x0100:
					SetCursor( LoadCursor( NULL, IDC_SIZEALL ) );
					break;
				case 0x0101:
					SetCursor( LoadCursor( NULL, IDC_SIZENESW ) );
					break;
				case 0x0102:
					SetCursor( LoadCursor( NULL, IDC_SIZENS ) );
					break;
				case 0x0103:
					SetCursor( LoadCursor( NULL, IDC_SIZENWSE ) );
					break;
				case 0x0104:
					SetCursor( LoadCursor( NULL, IDC_SIZEWE ) );
					break;
				case 0x0105:
					SetCursor( LoadCursor( NULL, IDC_SIZE ) );
					break;
				case 0x0106:
					SetCursor( LoadCursor( NULL, IDC_UPARROW ) );
					break;
/*
  8  IDC_SIZEALL	Double-pointed arrow pointing north/south/east/west
  9  IDC_SIZENESW	Double-pointed arrow pointing northeast and southwest
 10  IDC_SIZENS		Double-pointed arrow pointing north and south
 11  IDC_SIZENWSE	Double-pointed arrow pointing northwest and southeast
 12  IDC_SIZEWE		Double-pointed arrow pointing west and east
 13  IDC_SIZE		not supported under Windows 98 
 14  IDC_UPARROW	Vertical arrow
*/
			}
			break;

		case WM_LBUTTONDOWN:
			if( ! Visible ) ShowCursor( TRUE );
			Visible = TRUE;
			SetCursor( LoadCursor( NULL, IDC_ARROW ) );
			break;

		case WM_RBUTTONDOWN:
			if( Visible ) ShowCursor(FALSE);
			Visible = FALSE;
			break;

		case WM_RBUTTONUP:
			if( ! Visible ) ShowCursor(TRUE);
			Visible = TRUE;
			break;

//======================================================//
// optional == omit WM_PAINT for plain gray background  //
//             or include to show child window outlines //
//======================================================//
		case WM_PAINT:
		{
			int x, x1, y, y1;

			for( x=0; x<7; x++ )
				for( y=0; y<2; y++ )
					if( hwnd == hwndChild[x][y] )
					{	x1 = x;  y1 = y;	}
			hdc = BeginPaint( hwnd, &ps );
			GetClientRect( hwnd, &rect );
			Rectangle( hdc, 0, 0, rect.right, rect.bottom );

			DrawText( hdc, szArrowName[x1][y1], 
					  strlen( szArrowName[x1][y1] ),
					  &rect, DT_CENTER | DT_VCENTER | DT_SINGLELINE );
			EndPaint( hwnd, &ps );
		}
		break;

		default:
			return( DefWindowProc( hwnd,   msg,
								   wParam, lParam ) );
	}
	return 0;
}


long APIENTRY WndProc( HWND hwnd,   UINT msg,
                       UINT wParam, LONG lParam )
{
	short        cxWin, cyWin, x, y;

	switch( msg )
	{
		case WM_CREATE:
			for( x=0; x<7; x++ )
				for( y=0; y<2; y++ )
					hwndChild[x][y] =
						CreateWindow( szChildClass,     // LPSTR class name
						NULL,							// LPSTR window name
						WS_CHILDWINDOW | WS_VISIBLE,	// DWORD style
						0,								// position x (int)
						0,								// position y (int)
						0,								// size x     (int)
						0,								// size y     (int)
						hwnd,							// HWND parent
				(HMENU)  ( x | y << 8 ),				// child window id or menu
				(HANDLE) GetWindowLong( hwnd, GWL_HINSTANCE ),
				(LPVOID) NULL );						// LPVOID lpParam
			break;

		case WM_SIZE:
			cxWin = LOWORD( lParam ) / 7;
			cyWin = HIWORD( lParam ) / 2;
			for( x=0; x<7; x++ )
				for( y=0; y<2; y++ )
					MoveWindow( hwndChild[x][y],
								x*cxWin, y*cyWin,
								cxWin, cyWin, TRUE );
			break;

		case WM_LBUTTONDOWN:	MessageBeep(0);		break;

		case WM_DESTROY:		PostQuitMessage(0);	break;

		default:
			return( DefWindowProc( hwnd,   msg,
                                   wParam, lParam ) );
	}
	return 0;
}

#include "template.i"

int APIENTRY WinMain( HANDLE hInstance, HANDLE hPrevInstance,
                      LPSTR  lpCmdLine, int    nCmdShow    )
{
	WNDCLASS wc;
	MSG      msg;

	if( ! hPrevInstance )
	{
		if( ! InitApplication( hInstance ) )
			return( FALSE );
		//*** also register child window class ***//
		wc.style         = CS_HREDRAW | CS_VREDRAW;
		wc.cbClsExtra    = 0;
		wc.hInstance     = hInstance;
		wc.hbrBackground = GetStockObject( LTGRAY_BRUSH );
		wc.lpszMenuName  = NULL;
		wc.lpfnWndProc   = ChildWndProc;
		wc.cbWndExtra    = sizeof( WORD );
		wc.hIcon         = NULL;
		wc.hCursor       = NULL;          // essential!!! //
		wc.lpszClassName = szChildClass;
		RegisterClass( &wc );

	}
	if( ! InitInstance( hInstance, nCmdShow ) )
		return (FALSE);
	while( GetMessage( &msg, NULL, 0, 0 ) )
	{
		TranslateMessage( &msg );
		DispatchMessage( &msg );
	}
	return( msg.wParam );
	UNREFERENCED_PARAMETER( lpCmdLine );
}
