//===========================//
//         Button1.C         //
//  C++ Windows Button Demo  //
//===========================//

#include <windows.h>

#define APP_ICON  IDI_APPLICATION
#define APP_MENU  NULL

#define NUM (sizeof(button) / sizeof(button[0]) )
#define BWidth    16 * cxChr
#define BHeight    7 * cyChr / 4
#define BIndent1   3 * cxChr
#define BIndent2  24 * cxChr
#define BIndent3  45 * cxChr
#define BVStep1    3 * cyChr
#define BVStep2    5 * cyChr / 2
#define BSTYLE     WS_CHILD | WS_VISIBLE

HANDLE  hInst;
char    szAppTitle[] = "Window Button Types";
char    szAppName[]  = "Button1";
char	  szClass[]		= "button";
struct { long  style;
		   char* name;
			HMENU btnID;  }	button[] =
{
	BSTYLE | BS_GROUPBOX,		  "Push Button Group",			  NULL,	//  0
	BSTYLE | BS_PUSHBUTTON,		  "Push Button",			(HMENU) 0x01,	//  1
	BSTYLE | BS_DEFPUSHBUTTON,	  "Def Push Button",		(HMENU) 0x02,	//  2

	BSTYLE | BS_GROUPBOX,		  "Check Box Group",				  NULL,	//	 3
	BSTYLE | BS_CHECKBOX,		  "Check Box",				(HMENU) 0x11,	//  4
	BSTYLE | BS_AUTOCHECKBOX,	  "Auto Check Box",		(HMENU) 0x12,	//	 5
	BSTYLE | BS_3STATE,			  "Three State",			(HMENU) 0x13,	//	 6
	BSTYLE | BS_AUTO3STATE,		  "Auto Three State",	(HMENU) 0x14,	//	 7

	BSTYLE | BS_GROUPBOX,		  "Radio Button Group",			  NULL,	//	 8
	BSTYLE | BS_RADIOBUTTON,	  "Radio Button",			(HMENU) 0x21,	//	 9
	BSTYLE | BS_AUTORADIOBUTTON, "Auto Radio Button",	(HMENU) 0x22,	//	10
};

long FAR PASCAL WndProc( HWND hwnd,   UINT msg,
                         UINT wParam, LONG lParam )
{
   static char  szBuff[50];
   static HWND  hwndGroup1, hwndGroup2, hwndGroup3;
   static RECT  rect;
   static int   cxChr, cyChr;
   HDC          hdc;
   PAINTSTRUCT  ps;
   TEXTMETRIC   tm;

   switch( msg )
   {
      case WM_CREATE:
         hdc = GetDC( hwnd );
         SelectObject( hdc,
            GetStockObject( SYSTEM_FIXED_FONT ) );
         GetTextMetrics( hdc, &tm );
         cxChr = tm.tmAveCharWidth;
         cyChr = tm.tmHeight + tm.tmExternalLeading;
         ReleaseDC( hwnd, hdc );

         hwndGroup1 =
            CreateWindow
            (  szClass, button[0].name, button[0].style, 
					BIndent1 - 2 * cxChr, cyChr, 
					BWidth   + 4 * cxChr, cyChr * 11,
               hwnd, button[0].btnID,
		(HANDLE) ((LPCREATESTRUCT)lParam) -> hInstance,
	   (LPVOID) CreateWindow
		         (  szClass, button[1].name, button[1].style, 
						BIndent1, BVStep1, BWidth, BHeight,
						hwnd, button[1].btnID,
			(HANDLE) ((LPCREATESTRUCT)lParam) -> hInstance,
			(LPVOID) CreateWindow
		            (  szClass, button[2].name, button[2].style,
						   BIndent1, BVStep1 * 2, BWidth, BHeight,
		               hwnd, button[2].btnID,
				(HANDLE) ((LPCREATESTRUCT)lParam) -> hInstance,
						   NULL  
						)  
					)  
				);

         hwndGroup2 =
            CreateWindow
            (  szClass, button[3].name, button[3].style, 
					BIndent2 - 2 * cxChr, cyChr,
					BWidth   + 4 * cxChr, cyChr * 11,
               hwnd, button[3].btnID,
		(HANDLE) ((LPCREATESTRUCT)lParam) -> hInstance,
	   (LPVOID) CreateWindow
	            (  szClass, button[4].name, button[4].style, 
						BIndent2, BVStep2, BWidth, BHeight,  
						hwnd,  button[4].btnID,
		   (HANDLE) ((LPCREATESTRUCT)lParam) -> hInstance,
		   (LPVOID) CreateWindow
				      (  szClass, button[5].name, button[5].style,
		               BIndent2, BVStep2 * 2, BWidth, BHeight,
				         hwnd,  button[5].btnID,
				(HANDLE) ((LPCREATESTRUCT)lParam) -> hInstance,
			   (LPVOID) CreateWindow
						   (  szClass, button[6].name, button[6].style,
			               BIndent2, BVStep2 * 3, BWidth, BHeight,
						      hwnd,  button[6].btnID,
				   (HANDLE) ((LPCREATESTRUCT)lParam) -> hInstance,
					(LPVOID) CreateWindow
				            (  szClass, button[7].name, button[7].style,
								   BIndent2, BVStep2 * 4, BWidth, BHeight,
				               hwnd,  button[7].btnID,
					   (HANDLE) ((LPCREATESTRUCT)lParam) -> hInstance,
					            NULL  
								)  
							)  
						)  
					) 
				);

         hwndGroup3 =
            CreateWindow
            (  szClass, button[8].name, button[8].style,
               BIndent3 - 2 * cxChr, cyChr,
					BWidth   + 4 * cxChr, cyChr * 11,
               hwnd,  button[8].btnID,
	   (HANDLE) ((LPCREATESTRUCT)lParam) -> hInstance,
		(LPVOID) CreateWindow
	            (  szClass, button[9].name, button[9].style,
			         BIndent3, BVStep2 * 2,  BWidth,  BHeight,
				      hwnd,  button[9].btnID,
		   (HANDLE) ((LPCREATESTRUCT)lParam) -> hInstance,
		   (LPVOID) CreateWindow
				      (  szClass, button[10].name, button[10].style,
		               BIndent3, BVStep2 * 3,  BWidth+cxChr, BHeight,  
							hwnd,  button[10].btnID,
			   (HANDLE) ((LPCREATESTRUCT)lParam) -> hInstance,
						   NULL
						)
					)
				);
         break;

      case WM_SIZE:
         rect.left   =  2 * cxChr;
         rect.top    = 15 * cyChr;
         rect.right  = LOWORD( lParam );
         rect.bottom = HIWORD( lParam );
         break;

      case WM_PAINT:
         InvalidateRect( hwnd, &rect, TRUE );
         hdc = BeginPaint( hwnd, &ps );
         SelectObject( hdc,
            GetStockObject( SYSTEM_FIXED_FONT ) );
         SetBkMode( hdc, TRANSPARENT );
         TextOut( hdc, 2*cxChr, 13*cyChr,
            "(HIWORD)  wParam  (LOWORD)     lParam",
            37 );
         TextOut( hdc, 2*cxChr, 14*cyChr,
            "Notification   ControlID     WindowHandle",
            41 );
         TextOut( hdc, 2*cxChr, 14*cyChr,
            "____________  ____________   ____________",
            41 );
         EndPaint( hwnd, &ps );
         break;

      case WM_COMMAND:
         ScrollWindow( hwnd, 0, -cyChr, &rect, &rect );
         hdc = GetDC( hwnd );
         SelectObject( hdc,
            GetStockObject( SYSTEM_FIXED_FONT ) );
         TextOut( hdc, 2*cxChr,
                  cyChr * ( rect.bottom / cyChr - 1 ),
                  szBuff,
                  wsprintf( szBuff,
                     "   %04Xh         %04Xh"
                     "        %04X:%04Xh",
                     HIWORD(wParam), LOWORD(wParam),
                     HIWORD(lParam), LOWORD(lParam) ) );
         ReleaseDC( hwnd, hdc );
         ValidateRect( hwnd, NULL );
         break;

      case WM_DESTROY:  PostQuitMessage(0);  break;

      default:
         return( DefWindowProc( hwnd,   msg,
                                wParam, lParam ) );
   }
   return 0;
}

#include "Template.i"

int APIENTRY WinMain( HANDLE hInstance, HANDLE hPrevInstance,
                      LPSTR  lpCmdLine, int    nCmdShow    )
{
   MSG   msg;

   if( ! hPrevInstance )
      if( ! InitApplication( hInstance ) )
         return( FALSE );
   if( ! InitInstance( hInstance, nCmdShow ) )
      return (FALSE);
   while( GetMessage( &msg, NULL, 0, 0 ) )
   {
      TranslateMessage( &msg );
      DispatchMessage( &msg );
   }
   return( msg.wParam );
   UNREFERENCED_PARAMETER( lpCmdLine );
}

