//===========================//
//         Button2.C         //
//  C++ Windows Button Demo  //
//===========================//

#include <windows.h>

#define BWidth       16 * cxChr
#define BHeight       7 * cyChr / 4
#define BVStep1       3 * cyChr
#define BVStep2       5 * cyChr / 2
#define BStyle       WS_CHILD | WS_VISIBLE
#define AutoStyle    BStyle | BS_AUTORADIOBUTTON
#define CheckStyle   BStyle | BS_AUTOCHECKBOX
#define PButtonStyle BStyle | BS_PUSHBUTTON
#define APP_ICON     IDI_APPLICATION
#define APP_MENU     NULL

HINSTANCE hInst;
char		 szAppTitle[] = "Button Arrays";
char		 szAppName[]  = "Button2";

long FAR PASCAL WndProc( HWND hwnd,   UINT msg,
                         UINT wParam, LONG lParam )
{
   static char  szBuff[50];
   static HWND  hwndPB[4], hwndACB[5], hwndARB1[5],
                hwndARB2[5];
   static RECT  rect;
   static int   cxChr, cyChr, i;
   HDC          hdc;
//   PAINTSTRUCT  ps;
   TEXTMETRIC   tm;

   switch( msg )
   {
      case WM_CREATE:
         hdc = GetDC( hwnd );
         SelectObject( hdc,
            GetStockObject( SYSTEM_FIXED_FONT ) );
         GetTextMetrics( hdc, &tm );
         cxChr = tm.tmAveCharWidth;
         cyChr = tm.tmHeight + tm.tmExternalLeading;
         ReleaseDC( hwnd, hdc );

         hwndPB[0] =
            CreateWindow
            (  "button", " PushButtons ",
               BStyle | BS_GROUPBOX,
               cxChr, cyChr, 14 * cxChr, 13 * cyChr,
               hwnd, NULL, hInst, NULL );
         for( i=1; i<4; i++ )
         {
            wsprintf( szBuff, "Button #%d", i );
            hwndPB[i] =
               CreateWindow
               (  "button", szBuff, PButtonStyle,
                  2 * cxChr, BVStep1 * i,  10 * cxChr,
                  BHeight, hwndPB[0], (HMENU) i, hInst, NULL );
         }
         SendMessage( hwndPB[3], BM_SETSTYLE,
                      BStyle | BS_DEFPUSHBUTTON, 0L );
         hwndACB[0] =
            CreateWindow
            (  "button", "CheckBoxes",
               BStyle | BS_GROUPBOX,
               17 * cxChr, cyChr, 14 * cxChr, 13 * cyChr,
               hwnd, NULL, hInst, NULL );
         for( i=1; i<5; i++ )
         {
            wsprintf( szBuff, "Check #%d", i );
            hwndACB[i] =
               CreateWindow
               ( "button", szBuff, CheckStyle,
                  2 * cxChr, BVStep2 * i, 10 * cxChr,
                  BHeight, hwndACB[0], (HMENU)(i+5), hInst, NULL );
         }
         for( i=1; i<4; i++ )
         {
            SendMessage( hwndACB[i],
                         BM_SETCHECK, 1, 0L );
            SendMessage( hwndACB[i+1],
                         BM_SETSTATE, 1, 0L );
         }
         hwndARB1[0] =
            CreateWindow
            (  "button", "RadioButtons 1",
                BStyle | BS_GROUPBOX,
               33 * cxChr, cyChr, 14 * cxChr, 13 * cyChr,
               hwnd, NULL, hInst, NULL );
         for( i=1; i<5; i++ )
         {
            wsprintf( szBuff, "Radio #%d", i );
            hwndARB1[i] =
               CreateWindow
               ( "button", szBuff, AutoStyle,
                  2 * cxChr, BVStep2 * i, 10 * cxChr,
                  BHeight,
                  hwndARB1[0], (HMENU)(10+i), hInst, NULL );
         }
         for( i=1; i<=3; i++ )
         {
            SendMessage( hwndARB1[i], BM_SETCHECK, 1, 0L );
            SendMessage( hwndARB1[i], BM_SETSTATE, 1, 0L );
         }
         hwndARB2[0] =
            CreateWindow( "button", "RadioButtons 2",
                          BStyle | BS_GROUPBOX, 49 * cxChr, cyChr, 
								  14 * cxChr, 13 * cyChr,
                          hwnd, NULL, hInst, NULL );
         for( i=1; i<5; i++ )
         {
            wsprintf( szBuff, "Radio #%d", i );
            hwndARB2[i] =
               CreateWindow( "button", szBuff, AutoStyle | BS_LEFTTEXT,
					              2 * cxChr, BVStep2 * i, 10 * cxChr, BHeight,
                             hwndARB2[0], NULL,  hInst, NULL );
         }
         SendMessage( hwndARB2[3], BM_SETSTYLE, CheckStyle, 0L );
         break;

      case WM_SIZE:
         rect.left   =  2 * cxChr;
         rect.top    = 17 * cyChr;
         rect.right  = LOWORD( lParam );
         rect.bottom = HIWORD( lParam );
         break;

      case WM_DESTROY:  PostQuitMessage(0);  break;

      default:
         return( DefWindowProc( hwnd, msg, wParam, lParam ) );
   }
   return 0;
}

#include "Template.I"

int APIENTRY WinMain( HANDLE hInstance, HANDLE hPrevInstance,
                      LPSTR  lpCmdLine, int    nCmdShow    )
{
   MSG   msg;

   if( ! hPrevInstance )
      if( ! InitApplication( hInstance ) )
         return( FALSE );
   if( ! InitInstance( hInstance, nCmdShow ) )
      return (FALSE);
   while( GetMessage( &msg, NULL, 0, 0 ) )
   {
      TranslateMessage( &msg );
      DispatchMessage( &msg );
   }
   return( msg.wParam );
   UNREFERENCED_PARAMETER( lpCmdLine );
}


