// FileView2View.cpp : implementation of the CFileView2View class
//

#include "stdafx.h"
#include "FileView2.h"

#include "FileView2Doc.h"
#include "FileView2View.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFileView2View

IMPLEMENT_DYNCREATE(CFileView2View, CView)

BEGIN_MESSAGE_MAP(CFileView2View, CView)
	//{{AFX_MSG_MAP(CFileView2View)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_WM_VSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFileView2View construction/destruction

CFileView2View::CFileView2View()
{
	// TODO: add construction code here
	m_csFilePath.Empty();
	m_ChrX = 0;
	m_ChrY = 0; 
	m_ChrV = 0; 
	m_WndY = 0;
	m_WndX = 0;
	m_WndHeight = 0;
	m_HDisplay = 0;
	m_FilLines = 0;
	m_dwFilSz = 0;
	m_vScrlPos = 0;
	m_hScrlPos = 0;
	m_FixedFont = NULL;
}

CFileView2View::~CFileView2View()
{
}

BOOL CFileView2View::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CFileView2View drawing

void CFileView2View::OnDraw(CDC* pDC)
{
	CFileView2Doc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
	PaintFile( pDC );		// this is our draw function to display formatted data
}

/////////////////////////////////////////////////////////////////////////////
// CFileView2View diagnostics

#ifdef _DEBUG
void CFileView2View::AssertValid() const
{
	CView::AssertValid();
}

void CFileView2View::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CFileView2Doc* CFileView2View::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CFileView2Doc)));
	return (CFileView2Doc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CFileView2View message handlers

int CFileView2View::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	ShowScrollBar( SB_VERT, TRUE );

	LOGFONT		FontLog;            // font structure
	CDC*			pDC = GetDC();
   TEXTMETRIC	tm;

   FontLog.lfHeight         =  6;
   FontLog.lfWidth          =  6;
   FontLog.lfEscapement     =  0;
   FontLog.lfOrientation    =  0;
   FontLog.lfWeight         =  FW_NORMAL;
   FontLog.lfItalic         =  FALSE;
   FontLog.lfUnderline      =  FALSE;
   FontLog.lfStrikeOut      =  FALSE;
   FontLog.lfCharSet        =  ANSI_CHARSET;
   FontLog.lfOutPrecision   =  OUT_DEFAULT_PRECIS;
   FontLog.lfClipPrecision  =  CLIP_DEFAULT_PRECIS;
   FontLog.lfQuality        =  DEFAULT_QUALITY;
   FontLog.lfPitchAndFamily =  FIXED_PITCH | FF_DONTCARE;
   lstrcpy( FontLog.lfFaceName, "System" );
   m_FixedFont = CreateFontIndirect( (LPLOGFONT) &FontLog );
	pDC->SelectObject( m_FixedFont );
   pDC->GetTextMetrics( &tm );
   m_ChrX = tm.tmAveCharWidth;
   m_ChrY = tm.tmHeight + tm.tmExternalLeading;
   m_ChrV = tm.tmHeight;
   ReleaseDC( pDC );
	return 0;
}

void CFileView2View::OnFileOpen() 
{
	// TODO: Add your command handler code here
	CFileDialog*	pFileDlg;
	CString			csFilter;

	csFilter = "Bitmaps (*.bmp)|*.bmp|C/C++ files (*.C,*.CPP)|*.c;*.cpp|"
				  "Com files (*.com)|*.com|Cursors (*.cur)|*.cur|"
				  "Data (*.dat)|*.dat|DBase files (*.dbs)|*.dbs|"
				  "Dialogs (*.dlg)|*.dlg|Dynamic link libraries (*.dll)|*.dll|"
				  "Executables (*.exe)|*.exe|Headers (*.h,*.hpp)|*.h;*.hpp|"
				  "Palettes (*.pal)|*.pal|Resource scripts (*.rc)|*.rc|"
				  "Resource files (*.res)|*.res|Text files (*.txt)|*.txt|"
				  "All files (*.*)|*.*||";
	pFileDlg = new CFileDialog( TRUE, NULL, NULL,
										 OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
										 csFilter );
	if( pFileDlg->DoModal() == IDOK )
	{
		m_csFilePath = pFileDlg->GetPathName();
		OpenFile();
	}
	delete pFileDlg;
}

//======================================================//
// PaintFile: if FilLines is greater than zero, reads   //
//            and displays some portion of the file     //
//            according to the size and scroll position //
//    return: nothing                                   //
//      note: file is opened, read and closed. Files    //
//            should not remain open over multiple      //
//            Window messages.                          //
//======================================================//

void CFileView2View::PaintFile( CDC *pDC )
{
   LONG     lFilOfs;
   int      i, iFilSz, iTxtSz, lPos;
	CString	csBuff;
   HANDLE	hBuff;
	int		hFile;
   LPSTR    lpStr1, lpStr2;

	pDC->SelectObject( m_FixedFont );   // use fixed font in DC
   if( ! m_FilLines )
		return;

   if( ( hFile = _lopen( m_csFilePath, OF_READ ) ) == -1 )
		return;
		//=== get buffer to hold data ===
   iFilSz = m_WndHeight * m_HDisplay;
   hBuff = GlobalAlloc( GMEM_MOVEABLE, (DWORD) iFilSz );

	if( hBuff )
	{		//=== lock buffer for pointer ===
		lpStr1 = (char*) GlobalLock( hBuff );
		if( lpStr1 )
		{		//=== get file offset to start ===
			lFilOfs = (LONG) m_vScrlPos * m_HDisplay;
			if( _llseek( hFile, lFilOfs, 0 ) != -1L )
			{
				iTxtSz =
					_lread( hFile, lpStr1, iFilSz );
				if( iTxtSz != -1 )
				{
					lPos = 0;
					lpStr2 = lpStr1;
					for( i = m_vScrlPos; i < ( m_vScrlPos + m_WndHeight ); i++ )
					{
						if( iTxtSz > m_HDisplay )
							iFilSz = m_HDisplay;
						else
							iFilSz = iTxtSz;
						iTxtSz -= iFilSz;
						csBuff = FormatLine( lpStr2, iFilSz, 
													(char *)(i * m_HDisplay) );
						pDC->TextOut( m_ChrX * (-m_hScrlPos + 0),
										  m_ChrY * lPos++, csBuff );
						lpStr2 += m_HDisplay;
					}
				}
			}
			GlobalUnlock( hBuff );
		}
		GlobalFree( hBuff );
   }
   _lclose( hFile );
}

//======================================================//
// FormatLine: formats 8/16 bytes per line for display, // 
//             beginning with file offset, hex values   //
//             grouped by fours and ASCII text at end.  //
//    returns: pointer to szBuff                        //
//======================================================//

CString CFileView2View::FormatLine( CString csBuffIn, int iLen, char* LnOfs )
{
   int            i, j;
   unsigned char  chr;
	CString			csTemp1, csTemp2, csBuffOut;

   i = j = 0;
	csTemp1.Format( "%04X  ", LnOfs );		// line offset
	csBuffOut += csTemp1;						// add to buff
   for( i=0; i<min( iLen, m_HDisplay ); i++ )
   {
		chr = csBuffIn[i];
      if( (i+1) % 4 )                     // write hex in
			csTemp1.Format( "%02X ", chr );
      else                                // columns of four
			csTemp1.Format( "%02X  ", chr );
		csBuffOut += csTemp1;
      if( ( chr >= 0x20 && chr <= 0x7E ) ||
          ( chr >= 0xA0 && chr <= 0xFE ) )
         csTemp2 += chr;
      else
         csTemp2 += '.';
   }
   csTemp2 += '\0';            
   for( j=i; j<m_HDisplay; j++ )
   {
      if( (j+1) % 4 ) csBuffOut += "   ";
                 else csBuffOut += "    ";
      csTemp2 += " ";
   }
	csTemp1.Format( " [%s]", csTemp2 );
	csBuffOut += csTemp1;
   return csBuffOut;
}

void CFileView2View::OpenFile()
{
	CFile		cFile;
	CString	csBuff;

   if( cFile.Open( m_csFilePath, OF_CANCEL | OF_PROMPT | OF_READ ) )
   {
      m_dwFilSz = cFile.GetLength();
      m_FilLines = (int)(( m_dwFilSz + m_HDisplay - 1L ) / m_HDisplay );
      csBuff = FormatLine( m_csFilePath, m_HDisplay, NULL );
      m_WndWidth = csBuff.GetLength();       // get display width
      m_vScrlPos = m_hScrlPos = 0;
      cFile.Close();  
   }
   else
      m_FilLines = m_WndWidth = 0;		      // if file open failed
   m_WndHeight = min( m_FilLines, m_WndY / m_ChrY );
	SetScrollBar();
	Invalidate();
}

void CFileView2View::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
   m_WndY = cy;   // vert size
   m_WndX = cx;   // horiz size
   m_WndY = ( m_WndY / m_ChrV + 1 ) * m_ChrV;
   if( ( m_WndX / m_ChrX ) < 60 )
		m_HDisplay =  8L;
	else
		m_HDisplay = 16L;
   m_FilLines = (int)( ( m_dwFilSz + m_HDisplay - 1L ) / m_HDisplay );
   m_WndHeight = min( m_FilLines, m_WndY / m_ChrY );
	SetScrollBar();
}

void CFileView2View::SetScrollBar()
{
   m_vScrlMax = max( 0, m_FilLines + 1 - (int)( m_WndY / m_ChrY ) );
   m_vScrlPos = min( m_vScrlPos, m_vScrlMax );
   SetScrollRange( SB_VERT, 0, m_vScrlMax, FALSE );
   SetScrollPos(	 SB_VERT,	 m_vScrlPos, TRUE );
}

BOOL CFileView2View::OnScroll(UINT nScrollCode, UINT nPos, BOOL bDoScroll) 
{
	//=== NOTE: used for autoscrolling / OLE drop target operations
	//=== not relevant to normal scrolling operations
	return CView::OnScroll(nScrollCode, nPos, bDoScroll);
}

BOOL CFileView2View::OnScrollBy(CSize sizeScroll, BOOL bDoScroll) 
{
	//=== NOTE: called by CWnd::OnHScroll and CWnd::OnVScroll to perform
	//=== scrolling request -- not relevant to normal scrolling operations

	return CView::OnScrollBy(sizeScroll, bDoScroll);
}

void CFileView2View::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	int	vInc;

   switch( nSBCode )
   {
      case SB_TOP:		vInc = -m_vScrlPos;                 break;
      case SB_BOTTOM:	vInc =  m_vScrlMax - m_vScrlPos;    break;
      case SB_LINEUP:	vInc = -1;                          break;
      case SB_LINEDOWN: vInc =  1;                          break;
      case SB_PAGEUP:	vInc = -max( 1, m_WndY / m_ChrY );  break;
      case SB_PAGEDOWN:	vInc =  max( 1, m_WndY / m_ChrY );	break;
      case SB_THUMBPOSITION:	vInc = nPos - m_vScrlPos;		break;
      case SB_THUMBTRACK:		vInc = nPos - m_vScrlPos;		break;
      default:		      vInc = 0;
   }
   vInc = max( -m_vScrlPos, min( vInc, m_vScrlMax - m_vScrlPos ) );
   if( vInc )
   {
      m_vScrlPos += vInc;
      ScrollWindow( 0, -m_ChrY * vInc );
      SetScrollPos( SB_VERT, m_vScrlPos, TRUE );
      UpdateWindow();
   }
	CView::OnVScroll(nSBCode, nPos, pScrollBar);
}
