 // PopupsView.cpp : implementation of the CPopupsView class
//

#include "stdafx.h"
#include "Popups.h"

#include "PopupsDoc.h"
#include "PopupsView.h"
#include "TipWnd.h"
#include "TestDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPopupsView

IMPLEMENT_DYNCREATE(CPopupsView, CView)

BEGIN_MESSAGE_MAP(CPopupsView, CView)
	//{{AFX_MSG_MAP(CPopupsView)
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	ON_WM_SIZE()
	ON_COMMAND(IDM_TEST_DIALOG, OnTestDialog)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPopupsView construction/destruction

CPopupsView::CPopupsView()
{
	// TODO: add construction code here
}

CPopupsView::~CPopupsView()
{
}

BOOL CPopupsView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CPopupsView drawing

void CPopupsView::OnDraw(CDC* pDC)
{
	CPopupsDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
	CPoint	cPoint[2];

	GetClientRect( m_cRect );
	cPoint[0] = CPoint( 0, m_cRect.Height()/2 );
	cPoint[1] = CPoint( m_cRect.Width(), m_cRect.Height()/2 );
	pDC->Polyline( cPoint, 2 );
	cPoint[0] = CPoint( m_cRect.Width()/2, 0 );
	cPoint[1] = CPoint( m_cRect.Width()/2, m_cRect.Height() );
	pDC->Polyline( cPoint, 2 );
}

/////////////////////////////////////////////////////////////////////////////
// CPopupsView printing

BOOL CPopupsView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CPopupsView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CPopupsView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CPopupsView diagnostics

#ifdef _DEBUG
void CPopupsView::AssertValid() const
{
	CView::AssertValid();
}

void CPopupsView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CPopupsDoc* CPopupsView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CPopupsDoc)));
	return (CPopupsDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CPopupsView message handlers

void CPopupsView::OnInitialUpdate() 
{
	CView::OnInitialUpdate();
	GetClientRect( m_cRect );
}

void CPopupsView::OnSize( UINT nType, int cx, int cy ) 
{
	CView::OnSize(nType, cx, cy);
	GetClientRect( m_cRect );
}

void CPopupsView::OnLButtonDown( UINT nFlags, CPoint point ) 
{
	if( point.x > ( m_cRect.Width() / 2 ) )
		m_nQuad = 2;  else  m_nQuad = 0;

	if( point.y > ( m_cRect.Height() / 2 ) )
		m_nQuad ++;
	
	PopupTips( m_nQuad );
//	CView::OnLButtonDown(nFlags, point);
}

//			0		|		2
//		------------+--------------
//			1		|		3

void CPopupsView::OnRButtonDown( UINT nFlags, CPoint point ) 
{
	if( point.x > ( m_cRect.Width() / 2 ) )
		m_nQuad = 2;  else  m_nQuad = 0;

	if( point.y > ( m_cRect.Height() / 2 ) )
		m_nQuad ++;

	PopupMenu( m_nQuad );
//	CView::OnRButtonDown(nFlags, point);
}

void CPopupsView::PopupMenu( int nQuad )
{
	CPoint	cPoint;
	CMenu *	pMenu;

	cPoint = CPoint( m_cRect.Width()/5, m_cRect.Height()/5 );
	switch( nQuad )
	{
		case 0:									break;
		case 1:	cPoint.y += m_cRect.Height()/2;	break;
		case 2:	cPoint.x += m_cRect.Width()/2;	break;
		case 3:	cPoint.y += m_cRect.Height()/2;	
				cPoint.x += m_cRect.Width()/2;	break;
	}
	ClientToScreen( &cPoint );

	pMenu = new CMenu();
	pMenu->CreatePopupMenu();
	pMenu->AppendMenu( MF_STRING, ID_POPUP_MENU1, "Item 1" );
	pMenu->AppendMenu( MF_STRING, ID_POPUP_MENU2, "Item 2" );
	pMenu->AppendMenu( MF_STRING, ID_POPUP_MENU3, "Item 3" );
	pMenu->AppendMenu( MF_STRING, ID_POPUP_MENU4, "Item 4" );
	pMenu->AppendMenu( MF_STRING, ID_POPUP_MENU5, "Item 5" );
	pMenu->EnableMenuItem( ID_POPUP_MENU1 + nQuad,
						   MF_GRAYED | MF_BYCOMMAND | MF_DISABLED );
	pMenu->TrackPopupMenu( TPM_LEFTALIGN | TPM_RIGHTBUTTON,
						   cPoint.x, cPoint.y, this );
}

//			0		|		2
//		------------+--------------
//			1		|		3

void CPopupsView::PopupTips( int nQuad )
{
	CPoint	cPoint;
	CString	csTip;
	CTipWnd	*pTip;

	cPoint = CPoint( m_cRect.Width()/6, m_cRect.Height()/6 );
	switch( nQuad )
	{
		case 0:	 
			csTip = "This is a simple popup message";  
			break;

		case 1:	 
			cPoint.y += m_cRect.Height()/2;  
			csTip = "Important Message\r\nPay attention!";  
			break;

		case 2:	 
			cPoint.x += m_cRect.Width()/2;	  
			csTip = "This 3rd quadrant message\r\n"
					"has several line breaks\r\n"
					"for a three line display";  
			break;

		case 3:	 
			cPoint.y += m_cRect.Height()/2;	
			cPoint.x += m_cRect.Width()/2;	  
			csTip = "Just because this is a popup that\r\n"
					"doesn't mean that we can't provide\r\n"
					"a moderately long message. But not\r\n"
					"too long, of course.";
			break;
	}
	ClientToScreen( &cPoint );
	pTip = new CTipWnd();
	pTip->Create( csTip, cPoint );
}

BOOL CPopupsView::OnCommand( WPARAM wParam, LPARAM lParam ) 
{
	CString	csResponse = "You selected ";
	
	switch( wParam )
	{
		case ID_POPUP_MENU1:  csResponse += "Item 1";  break;
		case ID_POPUP_MENU2:  csResponse += "Item 2";  break;
		case ID_POPUP_MENU3:  csResponse += "Item 3";  break;
		case ID_POPUP_MENU4:  csResponse += "Item 4";  break;
		case ID_POPUP_MENU5:  csResponse += "Item 5";  break;
	}
	MessageBox( csResponse );
	return CView::OnCommand( wParam, lParam );
}

void CPopupsView::OnTestDialog() 
{
	CTestDlg	cTestDlg;

	cTestDlg.DoModal();
}
