// TestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Popups.h"
#include "TipWnd.h"
#include "TestDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define __AUTORADIOMENU__

/////////////////////////////////////////////////////////////////////////////
// CTestDlg dialog

CTestDlg::CTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestDlg::IDD, pParent)
{
	m_bCheckName = TRUE;
	m_bCheckPassword = FALSE;
	m_bCheckPopupMenu = FALSE;
	//{{AFX_DATA_INIT(CTestDlg)
	m_csUserName = _T("");
	m_csPassword = _T("");
	//}}AFX_DATA_INIT
}

void CTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestDlg)
	DDX_Text(pDX, IDC_USER_NAME, m_csUserName);
	DDX_Text(pDX, IDC_USER_PASSWORD, m_csPassword);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTestDlg, CDialog)
	//{{AFX_MSG_MAP(CTestDlg)
	ON_EN_KILLFOCUS(IDC_USER_NAME, OnKillfocusUserName)
	ON_EN_KILLFOCUS(IDC_USER_PASSWORD, OnKillfocusUserPassword)
	ON_WM_RBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestDlg message handlers

void CTestDlg::OnCancel() 
{
	GetClientRect( &m_cRect );
	m_cPoint.y = m_cRect.Height()/2;	
	m_cPoint.x = m_cRect.Width()/2;	  
	m_csTip = "Sorry that you're giving up\r\n"
			  "Please try again sometime";
	ClientToScreen( &m_cPoint );
	m_pTip = new CTipWnd();
	m_pTip->Create( m_csTip, m_cPoint );
	CDialog::OnCancel();
}

void CTestDlg::OnOK() 
{
	UpdateData();
	if( m_csUserName.GetLength() < 2 )
	{
		GetDlgItem( IDC_USER_NAME )->GetClientRect( &m_cRect );
		m_cPoint.y = m_cRect.Height()/2;	
		m_cPoint.x = m_cRect.Width()/2;	  
		ClientToScreen( &m_cPoint );
		m_csTip = "Really, old chap,\r\n"
				  "You must hame more of a name than this!\r\n"
				  "There's no need to be shy";
		m_pTip = new CTipWnd();
		m_pTip->Create( m_csTip, m_cPoint );
		GetDlgItem( IDC_USER_NAME )->SetFocus();
	}
	else
	if( m_csPassword.GetLength() < 8 )
	{
		GetDlgItem( IDC_USER_PASSWORD )->GetClientRect( &m_cRect );
		m_cPoint.y = m_cRect.Height()/2;	
		m_cPoint.x = m_cRect.Width()/2;	  
		ClientToScreen( &m_cPoint );
		m_csTip = "We must insist on a password\r\n"
				  "containing at least eight characters.\r\n"
				  "Please use a random sequence but\r\n"
				  "be careful to remember your errors";
		m_pTip = new CTipWnd();
		m_pTip->Create( m_csTip, m_cPoint );
		GetDlgItem( IDC_USER_PASSWORD )->SetFocus();
	}
	else	
	{
		GetClientRect( &m_cRect );
		m_cPoint.y = m_cRect.Height()/2;	
		m_cPoint.x = m_cRect.Width()/2;	  
		m_csTip = "Thank you for complying with our stupid\r\n"
				  "bureaucratic paranoia ...\r\n"
				  "You are now promoted to Serf First Class";
		ClientToScreen( &m_cPoint );
		m_pTip = new CTipWnd();
		m_pTip->Create( m_csTip, m_cPoint );
		CDialog::OnOK();
	}
}

void CTestDlg::OnKillfocusUserName() 
{
	if( m_bCheckName )
	{
		GetClientRect( &m_cRect );
		m_cPoint.y = m_cRect.left;	
		m_cPoint.x = m_cRect.top;	  
		UpdateData();
		if( m_csUserName.IsEmpty() )
		{
			m_csTip = "No skipping out now,\r\n"
					  "Please enter your name first";
			ClientToScreen( &m_cPoint );
			m_pTip = new CTipWnd();
			m_pTip->Create( m_csTip, m_cPoint );
			GetDlgItem( IDC_USER_NAME )->SetFocus();
		}
	}
}

void CTestDlg::OnKillfocusUserPassword() 
{
	if( m_bCheckPassword )
	{
		GetClientRect( &m_cRect );
		m_cPoint.y = m_cRect.left;	
		m_cPoint.x = m_cRect.top;	  
		UpdateData();
		if( m_csPassword.IsEmpty() )
		{
			m_csTip = "Sorry, Security demands that\r\n"
					  "you must supply a password";
			ClientToScreen( &m_cPoint );
			m_pTip = new CTipWnd();
			m_pTip->Create( m_csTip, m_cPoint );
			GetDlgItem( IDC_USER_PASSWORD )->SetFocus();
		}
	}
}

BOOL CTestDlg::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	CMenu	*pMenu = GetMenu();
	
	switch( LOWORD( wParam ) )
	{
		case ID_SELECT_CHECKNAME:
			m_bCheckPopupMenu = FALSE;
			m_bCheckPassword = FALSE;
			m_bCheckName = TRUE;
#ifdef __AUTORADIOMENU__
			pMenu->CheckMenuRadioItem( ID_SELECT_CHECKNAME,
									   ID_SELECT_POPUP_MENU,
									   ID_SELECT_CHECKNAME,
									   MF_BYCOMMAND );
#else
			pMenu->CheckMenuItem( ID_SELECT_CHECKNAME, 
								  MF_BYCOMMAND | MF_CHECKED );
			pMenu->CheckMenuItem( ID_SELECT_POPUP_MENU,
								  MF_BYCOMMAND | MF_UNCHECKED );
			pMenu->CheckMenuItem( ID_SELECT_CHECKPASSWORD,
								  MF_BYCOMMAND | MF_UNCHECKED );
#endif
			break;

		case ID_SELECT_POPUP_MENU:
			m_bCheckPopupMenu = TRUE;
			m_bCheckPassword = FALSE;
			m_bCheckName = FALSE;
#ifdef __AUTORADIOMENU__
			pMenu->CheckMenuRadioItem( ID_SELECT_CHECKNAME,
									   ID_SELECT_POPUP_MENU,
									   ID_SELECT_POPUP_MENU,
									   MF_BYCOMMAND );
#else
			pMenu->CheckMenuItem( ID_SELECT_CHECKNAME, 
								  MF_BYCOMMAND | MF_UNCHECKED );
			pMenu->CheckMenuItem( ID_SELECT_POPUP_MENU,
								  MF_BYCOMMAND | MF_CHECKED );
			pMenu->CheckMenuItem( ID_SELECT_CHECKPASSWORD,
								  MF_BYCOMMAND | MF_UNCHECKED );
#endif
			break;

		case ID_SELECT_CHECKPASSWORD:
			m_bCheckPopupMenu = FALSE;
			m_bCheckPassword = TRUE;
			m_bCheckName = FALSE;
#ifdef __AUTORADIOMENU__
			pMenu->CheckMenuRadioItem( ID_SELECT_CHECKNAME,
									   ID_SELECT_POPUP_MENU,
									   ID_SELECT_CHECKPASSWORD,
									   MF_BYCOMMAND );
#else
			pMenu->CheckMenuItem( ID_SELECT_CHECKNAME, 
								  MF_BYCOMMAND | MF_UNCHECKED );
			pMenu->CheckMenuItem( ID_SELECT_POPUP_MENU,
								  MF_BYCOMMAND | MF_UNCHECKED );
			pMenu->CheckMenuItem( ID_SELECT_CHECKPASSWORD,
								  MF_BYCOMMAND | MF_CHECKED );
#endif
			break;

		case ID_POPUP_MENU1:	m_csTip = "Option 1";	break;
		case ID_POPUP_MENU2:	m_csTip = "Option 2";	break;
		case ID_POPUP_MENU3:	m_csTip = "Option 3";	break;
	}
	switch( LOWORD( wParam ) )
	{
		case ID_POPUP_MENU1:
		case ID_POPUP_MENU2:
		case ID_POPUP_MENU3:
			m_pTip = new CTipWnd();
			m_pTip->Create( m_csTip, m_cPoint );
			break;
	}
	return CDialog::OnCommand(wParam, lParam);
}

void CTestDlg::OnRButtonDown(UINT nFlags, CPoint point) 
{
	m_cPoint = point;
	if( m_bCheckPopupMenu )
	{
		CMenu	*pMenu;

		ClientToScreen( &m_cPoint );
		pMenu = new CMenu();
		pMenu->CreatePopupMenu();
		pMenu->LoadMenu( IDR_POPUP_MENU );
		pMenu->AppendMenu( MF_STRING, ID_POPUP_MENU1, "Option 1" );
		pMenu->AppendMenu( MF_STRING, ID_POPUP_MENU2, "Option 2" );
		pMenu->AppendMenu( MF_STRING, ID_POPUP_MENU3, "Option 3" );
		pMenu->TrackPopupMenu( TPM_LEFTALIGN | TPM_RIGHTBUTTON,
							   m_cPoint.x, m_cPoint.y, this );
	}
	else
		CDialog::OnRButtonDown(nFlags, point);
}
