// TipWnd.cpp : implementation file
//

#include "stdafx.h"
#include "Popups.h"
#include "TipWnd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define DWCOLOR	0x0200FFFF

/////////////////////////////////////////////////////////////////////////////
// CTipWnd

CTipWnd::CTipWnd()
{
}

CTipWnd::~CTipWnd()
{
}

BEGIN_MESSAGE_MAP(CTipWnd, CWnd)
	//{{AFX_MSG_MAP(CTipWnd)
	ON_WM_PAINT()
	ON_WM_KEYDOWN()
	ON_WM_SYSKEYDOWN()
	ON_WM_LBUTTONDOWN()
	ON_WM_NCLBUTTONDOWN()
	ON_WM_MBUTTONDOWN()
	ON_WM_NCMBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	ON_WM_NCRBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CTipWnd message handlers

//BOOL CTipWnd::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 

BOOL CTipWnd::Create( CString csMessage, CPoint  cPoint )
{
	CBrush	cBrush;
	UINT	nResult;
	CSize	cSize;

	m_csMessage = csMessage;
	cSize = CalcWndSize();
	cBrush.CreateSolidBrush( DWCOLOR );
	LPCTSTR lpszTipClass =
		AfxRegisterWndClass( CS_HREDRAW | CS_VREDRAW, 
							 ::LoadCursor( NULL, IDC_ARROW ),
							 HBRUSH( cBrush ), NULL );
	nResult = CWnd::CreateEx( 
				  WS_EX_NOPARENTNOTIFY | WS_EX_TOPMOST | WS_EX_WINDOWEDGE,
				  lpszTipClass, csMessage, WS_POPUPWINDOW | WS_VISIBLE,
				  cPoint.x, cPoint.y, cSize.cx, cSize.cy,
				  GetSafeHwnd(), 0 );
	SetCapture();
	return nResult;
//	return CWnd::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CTipWnd::OnPaint() 
{
	CRect	 cRect;
	CPaintDC dc(this);		// device context for painting
	GetClientRect( cRect );
	cRect.DeflateRect( 5, 5, 5, 5 );
	dc.SetBkColor( DWCOLOR );
	dc.DrawText( m_csMessage, &cRect, DT_LEFT | DT_WORDBREAK );
	// Do not call CWnd::OnPaint() for painting messages
}

CSize CTipWnd::CalcWndSize()
{
	CDC		cDC;
	CSize	cSize, cSizeFinal;
	CString	csTemp;
	int		nLen, nLenTrim, nLines;

	cDC.CreateIC( _T("DISPLAY"), NULL, NULL, NULL );
	nLines = 0;
	nLenTrim = 0;
	cSizeFinal.cx = 0;
	cSizeFinal.cy = 0;
	csTemp = m_csMessage;
	do
	{
		nLen = csTemp.Find( "\r\n" );
		if( nLen > 0 )
		{
			csTemp = csTemp.Left( nLen );
			nLenTrim += ( nLen + 2 );
			nLines++;
			cSize = cDC.GetTextExtent( csTemp );
			csTemp = m_csMessage.Right( m_csMessage.GetLength() - nLenTrim );
		}
		else
		{
			nLines++;
			cSize = cDC.GetTextExtent( csTemp );
		}
		cSizeFinal.cy = cSize.cy;
		cSizeFinal.cx = max( cSizeFinal.cx, cSize.cx );
	}
	while( nLen >= 0 );
	cSizeFinal.cx += 15;	// add margin for borders
	cSizeFinal.cy *= nLines;
	cSizeFinal.cy += 15;	// add margin for borders
	return cSizeFinal;
}

void CTipWnd::ShutDown()
{
	PostMessage( WM_CLOSE );
	ReleaseCapture();
}

void CTipWnd::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	ShutDown();	
	CWnd::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CTipWnd::OnSysKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	ShutDown();	
	CWnd::OnSysKeyDown(nChar, nRepCnt, nFlags);
}

void CTipWnd::OnLButtonDown(UINT nFlags, CPoint point) 
{
	ShutDown();	
	CWnd::OnLButtonDown(nFlags, point);
}

void CTipWnd::OnNcLButtonDown(UINT nHitTest, CPoint point) 
{
	ShutDown();	
	CWnd::OnNcLButtonDown(nHitTest, point);
}

void CTipWnd::OnMButtonDown(UINT nFlags, CPoint point) 
{
	ShutDown();	
	CWnd::OnMButtonDown(nFlags, point);
}

void CTipWnd::OnNcMButtonDown(UINT nHitTest, CPoint point) 
{
	ShutDown();	
	CWnd::OnNcMButtonDown(nHitTest, point);
}

void CTipWnd::OnRButtonDown(UINT nFlags, CPoint point) 
{
	ShutDown();	
	CWnd::OnRButtonDown(nFlags, point);
}

void CTipWnd::OnNcRButtonDown(UINT nHitTest, CPoint point) 
{
	ShutDown();	
	CWnd::OnNcRButtonDown(nHitTest, point);
}
