// MultiThread.h : interface of the CThreadView class
//

#include "threads.h"

class CThreadView : public CView
{
protected: // create from serialization only
	CThreadView();
	DECLARE_DYNCREATE(CThreadView)

// Attributes
public:
	CClientDC *m_pDC;
	CTypedPtrList<CObList,CDemoThread*>     m_threadList;   
	CThreadDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CThreadView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	//}}AFX_VIRTUAL

// Implementation
public:
	void StartThread( int nThreadID );
	void UpdateTitle( int nThreads = -1 );
	virtual ~CThreadView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CThreadView)
	afx_msg void OnDestroy();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnCirclesAdd1();
	afx_msg void OnCirclesAdd10();
	afx_msg void OnCirclesAdd25();
	afx_msg void OnKillthreadsFast();
	afx_msg void OnKillthreadsSlow();
	afx_msg void OnLinesAdd1();
	afx_msg void OnLinesAdd5();
	afx_msg void OnLinesAdd10();
	afx_msg void OnRectanglesAdd1();
	afx_msg void OnRectanglesAdd10();
	afx_msg void OnRectanglesAdd25();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in mtgdivw.cpp
inline CThreadDoc* CThreadView::GetDocument()
   { return (CThreadDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
