// LevelCtrl2.h : Declaration of the CLevelCtrl2

#ifndef __LEVELCTRL2_H_
#define __LEVELCTRL2_H_

#include <math.h>
#include "resource.h"       // main symbols
#include "CPKnobCtrl2.h"

/////////////////////////////////////////////////////////////////////////////
// CLevelCtrl2
class ATL_NO_VTABLE CLevelCtrl2 : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CLevelCtrl2, &CLSID_LevelCtrl2>,
	public CComControl<CLevelCtrl2>,
	public CStockPropImpl<CLevelCtrl2, ILevelCtrl2, &IID_ILevelCtrl2, &LIBID_KNOBCTRL2Lib>,
//	public IProvideClassInfo2Impl<&CLSID_LevelCtrl2, NULL, &LIBID_KNOBCTRL2Lib>,
	public IProvideClassInfo2Impl<&CLSID_LevelCtrl2, &DIID__LevelEvents, &LIBID_KNOBCTRL2Lib>,
	public IPersistStreamInitImpl<CLevelCtrl2>,
	public IPersistStorageImpl<CLevelCtrl2>,
	public IQuickActivateImpl<CLevelCtrl2>,
	public IOleControlImpl<CLevelCtrl2>,
	public IOleObjectImpl<CLevelCtrl2>,
	public IOleInPlaceActiveObjectImpl<CLevelCtrl2>,
	public IViewObjectExImpl<CLevelCtrl2>,
	public IOleInPlaceObjectWindowlessImpl<CLevelCtrl2>,
	public IDataObjectImpl<CLevelCtrl2>,
	public ISupportErrorInfo,
	public ISpecifyPropertyPagesImpl<CLevelCtrl2>,
//
	public CProxy_LevelEvents<CLevelCtrl2>,
	public IConnectionPointContainerImpl<CLevelCtrl2>
{
public:
	CLevelCtrl2()
	{
		m_nLevel = 0;	// initial setting for level
		m_clrFillColor = RGB( 0xFF, 0xFF, 0 );
	}

DECLARE_REGISTRY_RESOURCEID(IDR_LEVELCTRL2)

BEGIN_COM_MAP(CLevelCtrl2)
	COM_INTERFACE_ENTRY(ILevelCtrl2)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY_IMPL(IViewObjectEx)
	COM_INTERFACE_ENTRY_IMPL_IID(IID_IViewObject2, IViewObjectEx)
	COM_INTERFACE_ENTRY_IMPL_IID(IID_IViewObject, IViewObjectEx)
	COM_INTERFACE_ENTRY_IMPL(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY_IMPL_IID(IID_IOleInPlaceObject, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY_IMPL_IID(IID_IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY_IMPL(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY_IMPL(IOleControl)
	COM_INTERFACE_ENTRY_IMPL(IOleObject)
	COM_INTERFACE_ENTRY_IMPL(IQuickActivate)
	COM_INTERFACE_ENTRY_IMPL(IPersistStorage)
	COM_INTERFACE_ENTRY_IMPL(IPersistStreamInit)
	COM_INTERFACE_ENTRY_IMPL(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY_IMPL(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY_IMPL(IConnectionPointContainer)
END_COM_MAP()

//=== next three lines added ===
BEGIN_CONNECTION_POINT_MAP(CLevelCtrl2)
	CONNECTION_POINT_ENTRY(DIID__LevelEvents)
END_CONNECTION_POINT_MAP()

BEGIN_PROPERTY_MAP(CLevelCtrl2)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	PROP_PAGE(CLSID_StockColorPage)
END_PROPERTY_MAP()

BEGIN_MSG_MAP(CLevelCtrl2)
	MESSAGE_HANDLER(WM_PAINT, OnPaint)
	MESSAGE_HANDLER(WM_SETFOCUS, OnSetFocus)
	MESSAGE_HANDLER(WM_KILLFOCUS, OnKillFocus)
//=== add map entries ===
	MESSAGE_HANDLER(WM_LBUTTONDOWN, OnLButtonDown)
	MESSAGE_HANDLER(WM_RBUTTONDOWN, OnRButtonDown)
END_MSG_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// IViewObjectEx
	STDMETHOD(GetViewStatus)(DWORD* pdwStatus)
	{
		ATLTRACE(_T("IViewObjectExImpl::GetViewStatus\n"));
		*pdwStatus = VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE;
		return S_OK;
	}

// ILevelCtrl2
public:
	STDMETHOD(get_nLevel)(/*[out, retval]*/ short *pVal);
	STDMETHOD(put_nLevel)(/*[in]*/ short newVal);
	HRESULT OnDraw(ATL_DRAWINFO& di);
	LRESULT	OnLButtonDown( UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL &bHandled );
	LRESULT	OnRButtonDown( UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL &bHandled );
	void	ChangeLevel( short newLevel );

	OLE_COLOR	m_clrFillColor;
	short		m_nLevel;
	POINT		m_arrPoint[5];
	RECT		m_rectLeft, m_rectRight;
};

#endif //__LEVELCTRL2_H_
