// LevelProp2.h : Declaration of the CLevelProp2

#ifndef __LEVELPROP2_H_
#define __LEVELPROP2_H_

#include "resource.h"       // main symbols
#include "KnobCtrl2.h"		// definition of ILevelCtrl

EXTERN_C const CLSID CLSID_LevelProp2;

/////////////////////////////////////////////////////////////////////////////
// CLevelProp2
class ATL_NO_VTABLE CLevelProp2 :
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CLevelProp2, &CLSID_LevelProp2>,
	public IPropertyPageImpl<CLevelProp2>,
	public CDialogImpl<CLevelProp2>
{
public:
	CLevelProp2() 
	{
		m_dwTitleID = IDS_TITLELevelProp2;
		m_dwHelpFileID = IDS_HELPFILELevelProp2;
		m_dwDocStringID = IDS_DOCSTRINGLevelProp2;
	}

	enum {IDD = IDD_LEVELPROP2};

DECLARE_REGISTRY_RESOURCEID(IDR_LEVELPROP2)

BEGIN_COM_MAP(CLevelProp2) 
	COM_INTERFACE_ENTRY_IMPL(IPropertyPage)
END_COM_MAP()

BEGIN_MSG_MAP(CLevelProp2)
	COMMAND_HANDLER( IDC_LEVEL2, EN_CHANGE, OnLevelChange )
	CHAIN_MSG_MAP(IPropertyPageImpl<CLevelProp2>)
END_MSG_MAP()

	STDMETHOD(Apply)(void)
	{
		USES_CONVERSION;
		ATLTRACE(_T("CLevelProp2::Apply\n"));
		for (UINT i = 0; i < m_nObjects; i++)
		{
			// Do something interesting here
			// ICircCtl* pCirc;
			// m_ppUnk[i]->QueryInterface(IID_ICircCtl, (void**)&pCirc);
			// pCirc->put_Caption(CComBSTR("something special"));
			// pCirc->Release();
			CComQIPtr<ILevelCtrl2, &IID_ILevelCtrl2> pLevel(m_ppUnk[i]);
			short nLevel = (short)GetDlgItemInt(IDC_LEVEL2);
			if FAILED( pLevel->put_nLevel( nLevel ) )
			{
				CComPtr<IErrorInfo> pError;
				CComBSTR			strError;
				GetErrorInfo( 0, &pError );
				pError->GetDescription(&strError);
				MessageBox( OLE2T(strError), _T("Error"), MB_ICONEXCLAMATION );
				return E_FAIL;
			}
		}
		m_bDirty = FALSE;
		return S_OK;
	}

	LRESULT OnLevelChange( WORD wNotify, WORD wID, HWND hWnd, BOOL &bHandled )
	{
		SetDirty(TRUE);
		return FALSE;
	}
};

#endif //__LEVELPROP2_H_
