//==================//
//     Color3.C     //
//  Windows Colors  //
//==================//

#include <windows.h>
#include <stdlib.h>
#include "color3.h"

#define  PalIndex     0x01000000 + i + ( j * 5 )
#define  xSteps       4
#define  ySteps       2
#define  CHILD_STYLE  WS_CHILD | WS_VISIBLE
#define  MIN( i )     min( 255, i + 1 )
#define  MAX( i )     max(   0, i - 1 )

FARPROC  lpScrlFnc[3];
HWND     hwndScrl[3], hwndTag[3], hwndVal[3], hwndRect;
HANDLE   hInst;
char     szBuff[10];
static int  nFocus, nPal = 0, CVal[3][8]  =
            { 0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFF,
              0x00, 0x00, 0xFF, 0xFF, 0x00, 0x00, 0xFF, 0xFF,
              0x00, 0xFF, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0xFF };

long APIENTRY KeybdProc( HWND hwnd,   UINT msg,
                         UINT wParam, LONG lParam )
{
	int i = GetWindowLong( hwnd, GWL_ID );

	switch( msg )
	{
		case WM_KEYDOWN:
			if( LOWORD( wParam ) == VK_TAB )
			{
				if( GetKeyState( VK_SHIFT ) )	i--;
										else	i++;
				if( i < 0 ) i = 2;
				else
				if( i > 2 ) i = 0;
				SetFocus( hwndScrl[ i % 3 ] );
			}  break;

		case WM_SETFOCUS:  nFocus = i;  break;
	}
	return( CallWindowProc( lpScrlFnc[i], hwnd, msg, wParam, lParam ) );
}

BOOL APIENTRY HelpProc( HWND hDlg,   UINT msg,
                        UINT wParam, LONG lParam )
{
	switch( msg )
	{
		case WM_INITDIALOG:
			return( TRUE );

		case WM_COMMAND:
		{
			switch( LOWORD( wParam ) )
			{
				case IDOK: EndDialog( hDlg, TRUE );	return( TRUE );
				default:							return( TRUE );
			}
		}
	}
	return( FALSE );
}

long APIENTRY WndProc( HWND hwnd,   UINT msg,
                       UINT wParam, LONG lParam )
{
	static LPLOGPALETTE  lPal;
	static int           i, j, k,   xSize, ySize, xOffset,
						 cxWnd, cyWnd, cyChr, cxChr;
	HPALETTE	NewPal;
	HBRUSH		NewBrush, OldBrush;
	HPEN		NewPen,   OldPen;
	HDC			hdc;
	PAINTSTRUCT	ps;
	TEXTMETRIC	tm;

	switch( msg )
	{
		case WM_CREATE:    // initialize the logical palette
			lPal = (LPLOGPALETTE)
				LocalAlloc( LMEM_FIXED | LMEM_ZEROINIT,
							sizeof(LOGPALETTE) +
							sizeof(PALETTEENTRY) * 8 );
			lPal->palVersion = 0x300;
			lPal->palNumEntries = 8;
			break;

		case WM_COMMAND:
			switch( LOWORD( wParam ) )
			{
				case IDM_PLUS:
					nPal++;
					if( nPal >= 8 ) nPal = 0;
					for( i=0; i<3; i++ )
					{
						SetScrollPos( hwndScrl[i], SB_CTL, CVal[i][nPal], TRUE );
						SetWindowText( hwndVal[i], itoa( CVal[i][nPal], szBuff, 10 ) );
					}
					InvalidateRect( hwnd, 0L, TRUE );
					break;

				case IDM_MINUS:
					nPal--;
					if( nPal < 0 ) nPal = 7;
					for( i=0; i<3; i++ )
					{
						SetScrollPos( hwndScrl[i], SB_CTL, CVal[i][nPal], TRUE );
						SetWindowText( hwndVal[i], itoa( CVal[i][nPal], szBuff, 10 ) );
					}
					InvalidateRect( hwnd, 0L, TRUE );
					break;

				case IDM_HELP:
					DialogBox( hInst, "COLOR3", hwnd, HelpProc );
					InvalidateRect( hwnd, 0L, TRUE );
					break;
			}
			break;

		case WM_PAINT:
			hdc = BeginPaint( hwnd, &ps );
			for( i=0; i<8; i++ )
			{
				lPal->palPalEntry[i].peRed   = CVal[0][i];
				lPal->palPalEntry[i].peGreen = CVal[1][i];
				lPal->palPalEntry[i].peBlue  = CVal[2][i];
				lPal->palPalEntry[i].peFlags = PC_RESERVED;
			}
			NewPal = CreatePalette( lPal );
			SelectPalette( hdc, NewPal, FALSE );
			RealizePalette( hdc );
			for( i=0; i<8; i++ )
			{
				j = i % 4;
				k = (int) i / 4;
				if( i == nPal )
					NewPen = CreatePen( PS_SOLID, 5, 0x007F7F7F );
				else
					NewPen = CreatePen( PS_SOLID, 1, PALETTEINDEX(i) );
				OldPen = SelectObject( hdc, NewPen );

				NewBrush = CreateSolidBrush( PALETTEINDEX(i) );
				OldBrush = SelectObject( hdc, NewBrush );

				Rectangle( hdc, 
						   xOffset + j * xSize + 4, 
						   k * ySize + 4,
						   xOffset + ( j + 1 ) * xSize - 4,
						   ( k + 1 ) * ySize - 4 );
				SelectObject( hdc, OldBrush );
				DeleteObject( NewBrush );
				SelectObject( hdc, OldPen );
				DeleteObject( NewPen );
			}
			EndPaint( hwnd, &ps );
			DeleteObject( NewPal );
			break;

		case WM_SIZE:
			cxWnd = LOWORD( lParam );
			cyWnd = HIWORD( lParam );

			hdc = GetDC( hwnd );
			GetTextMetrics( hdc, &tm );
			cyChr = tm.tmHeight;
			cxChr = tm.tmAveCharWidth;
			ReleaseDC( hwnd, hdc );
			xOffset = cxChr * 26;

			xSize = ( cxWnd - xOffset ) / xSteps;
			ySize =  cyWnd / ySteps;
			MoveWindow( hwndRect, 0, 0, cxChr * 26, cyWnd, TRUE );
			for( i=0; i<=2; i++ )
			{
				MoveWindow( hwndTag[i], cxChr * ( ( i * 8 ) + 2 ),
							(INT)(cyChr * 0.5), cxChr * 6, cyChr, TRUE );
				MoveWindow( hwndVal[i], cxChr * ( ( i * 8 ) + 2 ),
							cyWnd - (INT)( cyChr * 1.5 ),
							cxChr * 6,   cyChr, TRUE );
				MoveWindow( hwndScrl[i], cxChr * ( ( i * 8 ) + 2 ),
							(INT)(cyChr * 1.5), cxChr * 6,
							cyWnd - ( 3 * cyChr ), TRUE );
			}
			SetFocus( hwnd );
			break;

		case WM_VSCROLL:
			i = GetWindowLong( (HWND) lParam, GWL_ID );
			switch( LOWORD( wParam ) )
			{
				case SB_PAGEDOWN:	CVal[i][nPal] += 15;			  // no break!
				case SB_LINEDOWN:	CVal[i][nPal]  = MIN( CVal[i][nPal] );	break;
				case SB_PAGEUP:		CVal[i][nPal] -= 15;			  // no break!
				case SB_LINEUP:		CVal[i][nPal]  = MAX( CVal[i][nPal] );	break;
				case SB_TOP:		CVal[i][nPal]  =   0;           		break;
				case SB_BOTTOM:		CVal[i][nPal]  = 255;           		break;
				case SB_THUMBPOSITION:
				case SB_THUMBTRACK:	CVal[i][nPal] = HIWORD( wParam );		break;
			}
			SetScrollPos( hwndScrl[i], SB_CTL, CVal[i][nPal], TRUE );
			SetWindowText( hwndVal[i], itoa( CVal[i][nPal], szBuff, 10 ) );
			InvalidateRect( hwnd, 0L, TRUE );
			break;

		case WM_DESTROY:
			LocalFree( lPal );
			PostQuitMessage(0);
			break;

		default:	return( DefWindowProc( hwnd, msg, wParam, lParam ) );
	}
	return 0;
}

int PASCAL WinMain( HANDLE hInstance, HANDLE hPrevInst,
                    LPSTR  lpCmd,     int    nCmdShow )
{
	static char szAppName[] = "COLOR3";
	static char *szColorLabel[] = { "Red", "Green", "Blue" };
	FARPROC     lpfnKeybdProc;
	HWND        hwnd;
	MSG         msg;
	int         i;
	WNDCLASS    wc;

	if( ! hPrevInst )
	{
		wc.hInstance     = hInstance;
		wc.lpfnWndProc   = WndProc;
		wc.cbClsExtra    = 0;
		wc.cbWndExtra    = 0;
		wc.lpszClassName = szAppName;
		wc.hIcon         = LoadIcon( hInst, szAppName );
		wc.lpszMenuName  = (LPSTR) szAppName;
		wc.hCursor       = LoadCursor( 0L, IDC_ARROW );
		wc.hbrBackground = CreateSolidBrush( WHITE_BRUSH );
		wc.style         = CS_HREDRAW | CS_VREDRAW;
		RegisterClass( &wc );
	}
	hInst = hInstance;
	hwnd = CreateWindow( szAppName, "Custom Palette Colors",
						 WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN,
                         CW_USEDEFAULT, CW_USEDEFAULT,
                         CW_USEDEFAULT, CW_USEDEFAULT,
                         0L, 0L, hInst, 0L  );
	hwndRect = CreateWindow( "static", 0L, CHILD_STYLE | SS_WHITERECT,
							  0, 0, 0, 0, hwnd, (HMENU) 10, hInstance, 0L );
	lpfnKeybdProc = MakeProcInstance( (FARPROC) KeybdProc, hInstance );
	for( i=0; i<=2; i++ )
	{
		hwndScrl[i] = CreateWindow( "scrollbar", 0L,
									CHILD_STYLE | WS_TABSTOP | SBS_VERT,
									0, 0, 0, 0, hwnd, (HMENU) i, hInstance, 0L );
		hwndTag[i] = CreateWindow( "static", szColorLabel[i],
								   CHILD_STYLE | SS_CENTER,
								   0, 0, 0, 0, hwnd, (HMENU)(i+4), hInstance, 0L );
		hwndVal[i] = CreateWindow( "static", itoa( CVal[i][nPal], szBuff, 10 ),
								   CHILD_STYLE | SS_CENTER,
								   0, 0, 0, 0, hwnd, (HMENU)(i+7), hInstance, 0L );
		lpScrlFnc[i] = (FARPROC) GetWindowLong( hwndScrl[i], GWL_WNDPROC );
		SetWindowLong(  hwndScrl[i], GWL_WNDPROC, (LONG) lpfnKeybdProc );
		SetScrollRange( hwndScrl[i], SB_CTL, 0, 255, FALSE );
		SetScrollPos(   hwndScrl[i], SB_CTL, CVal[i][nPal], FALSE );
	}
	ShowWindow(   hwnd, nCmdShow );
	UpdateWindow( hwnd );
	while( GetMessage( &msg, 0L, 0, 0 ) )
	{
		TranslateMessage( &msg );
		DispatchMessage(  &msg );
	}
	return( msg.wParam );
}