//=======================//
//       BarGraph.C      //
//  C++ Windows Drawing  //
//=======================//

#include <windows.h>
#include <stdio.h>
#include "bargraph.h"

#define APP_ICON  "BARGRAPH"
// note: no cursor or menu assignment

HANDLE hInst;
char	szAppTitle[] = "Acme Bargraph";
char	szAppName[]  = "BarGraph";
int		Accounts[4][8] =
		{
			133, 35, 33, 17, 29, 15, 17, 32,
			122, 41, 30, 25, 18, 24, 43, 21,
			111, 65, 57, 14, 17, 39, 32, 17,
			100, 60, 70, 12, 16, 13, 17, 12  
		},
		Years[4] = { 1995, 1996, 1997, 1998 };

char *	AccTypes[9] =
		{
			"Motor",	"Acsry",	"Reprs",	"Govmt",
			"Lease",	"Tires",	"Paint",	"Misc "  
		};

COLORREF  lpColor[8] =
{
	RGB(  50,  50,  50 ),	RGB(  50,  50, 200 ),     // DarkGray,	Blue
	RGB(  50, 200,  50 ),	RGB(  50, 200, 200 ),     // Green,		Cyan
	RGB( 200,  50,  50 ),	RGB( 200,  50, 200 ),     // Red,		Magenta
	RGB( 200, 200,  50 ),	RGB( 200, 200, 200 )      // Yellow,	LightGray
};

long APIENTRY WndProc( HWND hwnd,   UINT msg,
                       UINT wParam, LONG lParam )
{
	static  int  cxWnd, cyWnd, OrgDC;
	HDC          hdc;
	HPEN         hPen;
	HBRUSH       hBrush;
	PAINTSTRUCT  ps;
	RECT         rect;
	int          i, j, MaxVal = 0;
	char         szBuff[10];

	switch( msg )
	{
		case WM_SIZE:
			cxWnd = LOWORD( lParam );
			cyWnd = HIWORD( lParam );
			InvalidateRect( hwnd, NULL, TRUE );
			break;

		case WM_PAINT:
			for( i=0; i<8; i++ )
				for( j=0; j<4; j++ )
					MaxVal = max( MaxVal, Accounts[j][i] );
			hdc = BeginPaint( hwnd, &ps );
			OrgDC = SaveDC( hdc );
			SetMapMode( hdc, MM_ANISOTROPIC );
			SetWindowExtEx( hdc, cxWnd,  MaxVal, NULL );
			SetViewportExtEx( hdc, cxWnd, -MaxVal, NULL );
			GetClientRect( hwnd, &rect );
			SetWindowOrgEx( hdc, -10, rect.bottom-20, NULL );
			for( i=-1; i<2*MaxVal; i+=50 )
			{
				MoveToEx( hdc, -10, i, NULL );
				LineTo( hdc, cxWnd, i );
			}
			for( i=0; i<8; i++ )
				TextOut( hdc, i*70+5, -2, szBuff,
						 sprintf( szBuff, "%s", AccTypes[i]));

			for( j=0; j<4; j++ )
			{
				TextOut( hdc, ( j + 1 ) * 70 + 20, 2 * MaxVal,
						 szBuff, sprintf( szBuff, "%d", Years[j] ) );
				hPen = CreatePen( PS_SOLID, 1, lpColor[j+1] );
				SelectObject( hdc, hPen );
				hBrush = CreateSolidBrush( lpColor[j+1] );
				SelectObject( hdc, hBrush );
				Rectangle( hdc, (j+1)*70, 2*MaxVal+20,
                           (j+1)*70+15, 2*MaxVal+5 );
				for( i=0; i<8; i++ )
					Rectangle( hdc, j * 15 + 1 + i * 70,
							   0, ( j + 1 ) * 15 + i * 70,
							   2 * Accounts[j][i] );
				DeleteObject( hPen );
				DeleteObject( hBrush );
			}
			RestoreDC( hdc, OrgDC );
			break;

		case WM_DESTROY:   PostQuitMessage(0);   break;

		default:
			return( DefWindowProc( hwnd, msg, wParam, lParam ) );
	}
	return 0;
}

#include "template.i"

int APIENTRY WinMain( HANDLE hInstance, HANDLE hPrevInstance,
                      LPSTR  lpCmdLine, int    nCmdShow    )
{
	MSG   msg;

	if( ! hPrevInstance )
		if( ! InitApplication( hInstance ) )
			return( FALSE );
	if( ! InitInstance( hInstance, nCmdShow ) )
		return (FALSE);
	while( GetMessage( &msg, NULL, 0, 0 ) )
	{
		TranslateMessage( &msg );
		DispatchMessage( &msg );
	}
	return( msg.wParam );
	UNREFERENCED_PARAMETER( lpCmdLine );
}
