//=======================//
//       PieGraph.C      //
//  C++ Windows Drawing  //
//=======================//

#include <windows.h>
#include <stdio.h>
#include <math.h>
#include "piegraph.h"

#define  PI2  3.1415 * 2.0
#define APP_ICON  "PIEGRAPH"
#define APP_MENU  "PIEGRAPH"
// note: no cursor assignment

HANDLE	hInst;
char	szAppTitle[] = "Acme Piegraph";
char	szAppName[]  = "PIEGRAPH";

int		Accounts[4][8] =
		{
			133, 35, 33, 17, 29, 15, 17, 32,
			122, 41, 30, 25, 18, 24, 43, 21,
			111, 65, 57, 14, 17, 39, 32, 17,
			100, 60, 70, 12, 16, 13, 17, 12  
		},
		Years[4] = { 1995, 1996, 1997, 1998 },
		Year = 0;

char *	AccTypes[9] =
		{
			"Motor", "Acsry", "Reprs", "Govmt",
			"Lease", "Tires", "Paint", "Misc " 
		};

COLORREF  lpColor[8] =
{
	RGB( 100, 100, 100 ),	RGB(  50,  50, 200 ),	// DarkGray, Blue
	RGB(  50, 200,  50 ),	RGB(  50, 200, 200 ),	// Green,    Cyan
	RGB( 200,  50,  50 ),	RGB( 200,  50, 200 ),	// Red,      Magenta
	RGB( 200, 200,  50 ),	RGB( 200, 200, 200 )	// Yellow,   LightGray
};

long APIENTRY WndProc( HWND hwnd,   UINT msg,
                       UINT wParam, LONG lParam )
{
	static  int  cxWnd, cyWnd, OrgDC;
	HDC          hdc;
	HPEN         hPen;
	HMENU        hMenu;
	HBRUSH       hBrush;
	PAINTSTRUCT  ps;
	RECT         rect;
	int          i, Radius, TotVal[9];
	char         szBuff[10];

	switch( msg )
	{
		case WM_CREATE:
			CheckMenuItem( GetMenu( hwnd ), Year+Y1995, MF_CHECKED );
			break;

		case WM_COMMAND:
			switch( LOWORD( wParam ) )
			{
				case Y1995:  case Y1996:
				case Y1997:  case Y1998:
					hMenu = GetMenu( hwnd );
					CheckMenuItem( hMenu, Year+Y1995, MF_UNCHECKED );
					Year = wParam - Y1995;
					CheckMenuItem( hMenu, wParam, MF_CHECKED );
					break;

				default:
					return( DefWindowProc( hwnd, msg, wParam, lParam ) );
			}
			InvalidateRect( hwnd, NULL, TRUE );
			break;

		case WM_SIZE:
			cxWnd = LOWORD( lParam );
			cyWnd = HIWORD( lParam );
			InvalidateRect( hwnd, NULL, TRUE );
			break;

		case WM_PAINT:
			TotVal[0] = 0;
			for( i=0; i<8; i++ )
				TotVal[i+1] = TotVal[i] + Accounts[Year][i];
			Radius = 150;
			hdc = BeginPaint( hwnd, &ps );
			OrgDC = SaveDC( hdc );
			SetMapMode( hdc, MM_ISOTROPIC );
			SetWindowExtEx( hdc, 400, 400, NULL );
			SetViewportExtEx( hdc, cxWnd, -cyWnd, NULL );
			SetViewportOrgEx( hdc, cxWnd/2, cyWnd/2, NULL );
			GetClientRect( hwnd, &rect );
			TextOut( hdc, 20-(cxWnd/4), 180, szBuff,
					 sprintf( szBuff, "%d", Year+Y1995 ) );
			for( i=0; i<8; i++ )
			{
				TextOut( hdc, 20-(cxWnd/4), (8-i)*20, szBuff,
						 sprintf( szBuff, "%s", AccTypes[i] ) );
				hPen = CreatePen( PS_SOLID, 1, lpColor[i] );
				SelectObject( hdc, hPen );
				hBrush = CreateSolidBrush( lpColor[i] );
				SelectObject( hdc, hBrush );
				Rectangle( hdc, -(cxWnd/4), (8-i)*20, -(cxWnd/4)+15, (8-i)*20-15 );
				Pie( hdc, -Radius, Radius, Radius, -Radius,
					(int) ( Radius * cos( PI2 * TotVal[i]   / TotVal[8] ) ),
					(int) ( Radius * sin( PI2 * TotVal[i]   / TotVal[8] ) ),
					(int) ( Radius * cos( PI2 * TotVal[i+1] / TotVal[8] ) ),
					(int) ( Radius * sin( PI2 * TotVal[i+1] / TotVal[8] ) ) );
				DeleteObject( hPen );
				DeleteObject( hBrush );
			}
			RestoreDC( hdc, OrgDC );
			break;

		case WM_DESTROY:  PostQuitMessage(0);   break;

		default:	return( DefWindowProc( hwnd, msg, wParam, lParam ) );
	}
	return 0;
}

#include "template.i"

int APIENTRY WinMain( HANDLE hInstance, HANDLE hPrevInstance,
                      LPSTR  lpCmdLine, int    nCmdShow    )
{
	MSG   msg;

	if( ! hPrevInstance )
		if( ! InitApplication( hInstance ) )
			return( FALSE );
	if( ! InitInstance( hInstance, nCmdShow ) )
		return (FALSE);
	while( GetMessage( &msg, NULL, 0, 0 ) )
	{
		TranslateMessage( &msg );
		DispatchMessage( &msg );
	}
	return( msg.wParam );
	UNREFERENCED_PARAMETER( lpCmdLine );
}
