//=======================//
//       PenDraw4.C      //
//  C++ Windows Drawing  //
//=======================//

#define OEMRESOURCE

#include <windows.h>
#include <stdio.h>
#include "pendraw4.h"

#define APP_ICON  "PenDraw4"
#define APP_MENU  "PenDraw4"
// note: no cursor assignment

HANDLE  hInst;
char    szAppTitle[] = "Pen Draw 4: Bitmapped Brushes";
char    szAppName[]  = "PenDraw4";
int     ply[] = {  6, 8  };
POINT   pt[] =  { -110, 100,  -52, -80, -205,  30,				// 5 pointed star
				   -15,  30, -168, -80, -110, 100,
				   110, 100,  153, -90,   32,  63, 207, -22,	// 7 pointed star
					13, -22,  188,  62,   67, -90, 110, 100  };

long APIENTRY WndProc( HWND hwnd,   UINT msg,
					   UINT wParam, LONG lParam )
{
	static int     i, j, cxWnd, cyWnd, nBitMap = IDM_BRICK;
	static HBITMAP hBitMap[4];
	HDC            hdc;
	HPEN           hPen;
	HMENU          hMenu;
	HBRUSH         hBrush;
	PAINTSTRUCT    ps;

	switch( msg )
	{
		case WM_CREATE:
			hBitMap[0] = LoadBitmap( hInst, "BRICKS"  );
			hBitMap[1] = LoadBitmap( hInst, "CHAINS"  );
			hBitMap[2] = LoadBitmap( hInst, "DIAMOND" );
			hBitMap[3] = LoadBitmap( hInst, "STRIPES" );
			break;

		case WM_COMMAND:
			hMenu = GetMenu( hwnd );
			switch( LOWORD(wParam) )
			{
				case IDM_BRICK:    case IDM_CHAINS:
				case IDM_DIAMOND:  case IDM_STRIPE:
					CheckMenuItem( hMenu, nBitMap, MF_UNCHECKED );
					nBitMap = wParam;
					CheckMenuItem( hMenu, nBitMap, MF_CHECKED);
					break;

				default: 
					return( DefWindowProc( hwnd, msg, wParam, lParam ) );
			}
			InvalidateRect( hwnd, NULL, TRUE );
			break;

		case WM_SIZE:
			cxWnd = LOWORD( lParam );
			cyWnd = HIWORD( lParam );
			InvalidateRect( hwnd, NULL, TRUE );
			break;

		case WM_PAINT:
			hdc = BeginPaint( hwnd, &ps );
			hPen = CreatePen( PS_SOLID, 3, 0L );
			SelectObject( hdc, hPen );
			hBrush = CreatePatternBrush( hBitMap[ nBitMap-IDM_BRICK ] );
			SelectObject( hdc, hBrush );
			SetMapMode( hdc, MM_ISOTROPIC );
			SetWindowExtEx( hdc, 440, -220, NULL );
			SetViewportExtEx( hdc, cxWnd, cyWnd, NULL );
			SetWindowOrgEx( hdc, -220, 110, NULL );
			SetPolyFillMode( hdc, ALTERNATE );
			PolyPolygon( hdc, pt, ply, 2 );
			EndPaint( hwnd, &ps );
			break;

		case WM_DESTROY:
			for( i=1; i<3; i++ )
				DeleteObject( hBitMap[i] );
			PostQuitMessage(0);
			break;

		default:
			return( DefWindowProc( hwnd, msg, wParam, lParam ) );
	}
	return 0;
}

#include "template.i"

int APIENTRY WinMain( HANDLE hInstance, HANDLE hPrevInstance,
                      LPSTR  lpCmdLine, int    nCmdShow    )
{
	MSG  msg;

	if( ! hPrevInstance )
		if( ! InitApplication( hInstance ) )
			return( FALSE );
	if( ! InitInstance( hInstance, nCmdShow ) )
		return (FALSE);
	while( GetMessage( &msg, NULL, 0, 0 ) )
	{
		TranslateMessage( &msg );
		DispatchMessage( &msg );
	}
	return( msg.wParam );
	UNREFERENCED_PARAMETER( lpCmdLine );
}

