// TargetView.h : interface of the CTargetView class
//
/////////////////////////////////////////////////////////////////////////////

enum tag_TARGET	{	NO_TARGET, ALL, LEFT, RIGHT, TOP, BOTTOM, 
					TOP_LEFT, TOP_RIGHT, BOTTOM_LEFT, BOTTOM_RIGHT };

class CTargetView : public CView
{
protected: // create from serialization only
	CTargetView();
	DECLARE_DYNCREATE(CTargetView)

// Attributes
public:
	CTargetDoc* GetDocument();

protected:
	BOOL			m_bDrawOverlay, m_bCapture;
	DWORD			m_bmWidth, m_bmHeight, m_bmImgSize, m_bmScanWidth;
	WORD			m_bmBitCount;
	HBITMAP			m_hBitmap;
	CPalette     *	m_pPal;
	LPLOGPALETTE	m_pLogPal;
	CRect			m_cRect;
	CPoint			m_cPoint;
	int				m_xRadius, m_yRadius;
	tag_TARGET		m_nTrack;
	HCURSOR			m_hCursor;

// Operations
public:
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTargetView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CTargetView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	BOOL ReadBitmap( CString csFName );
	void DrawOverlay();
	void DrawROITarget();
	void FreeGlobalVars();
	BOOL ErrorMsg( char* Error );
	void DrawTargets();
// Generated message map functions
protected:
	//{{AFX_MSG(CTargetView)
	afx_msg void OnFileOpen();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in TargetView.cpp
inline CTargetDoc* CTargetView::GetDocument()
   { return (CTargetDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
