// GrayImageView.h : interface of the CGrayImageView class
//
/////////////////////////////////////////////////////////////////////////////

class CGrayImageView : public CView
{
protected: // create from serialization only
	CGrayImageView();
	DECLARE_DYNCREATE(CGrayImageView)

// Attributes
public:
	CGrayImageDoc* GetDocument();

protected:
	DWORD				m_bmWidth, m_bmHeight, m_bmImgSize, m_bmScanWidth;
	WORD				m_bmBitCount;
	HBITMAP			m_hBitmap;
	CPalette     *	m_pPal;
	LPLOGPALETTE	m_pLogPal;
	CString			m_csFileName;
	HCURSOR			m_hCursor;
	BYTE         * m_pBits;
   LPBITMAPINFO   m_pBmInfo;
	HANDLE			m_hBmInfo;
	BOOL				m_bBitmap;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGrayImageView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CGrayImageView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	BOOL ReadBitmap( CString csFName );
	void FreeGlobalVars();
	BOOL ErrorMsg( char* Error );
// Generated message map functions
protected:
	//{{AFX_MSG(CGrayImageView)
	afx_msg void OnFileOpen();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in GrayImageView.cpp
inline CGrayImageDoc* CGrayImageView::GetDocument()
   { return (CGrayImageDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
