//=======================//
//       PenDraw6.C      //
//  C++ Windows Drawing  //
//  creating a metafile  //
//=======================//

#include <windows.h>
#include <stdio.h>
#include <math.h>

#define PI2 ( 2.0 * 3.1415 )                // radians in 360 degrees //
#define APP_ICON  "PenDraw6"
#define APP_MENU  "PenDraw6"
// note: no cursor assignment

HANDLE hInst;
char   szAppTitle[] = "Pen Draw 6: Metafile Images";
char   szAppName[]  = "PenDraw6";

int ErrorMsg( char * Message )
{
	MessageBox( GetFocus(), Message, "Notification",
				MB_ICONASTERISK | MB_OK );
	return( TRUE );
}

long APIENTRY WndProc( HWND hwnd,   UINT msg,
                       UINT wParam, LONG lParam )
{
	static int    cxWnd, cyWnd;
	static HANDLE hMetaFile;
	static POINT  pt[7];
	static char   szMetaFileName[90];
	static char   szTempPath[67];
	char          szBuff[100];
	HDC           hdc, hdcMeta;
	HPEN          hPen;
	PAINTSTRUCT   ps;
	int           i, j;

	switch( msg )
	{
		case WM_CREATE:
			GetTempPath( sizeof( szTempPath ), (LPSTR) szTempPath );
			GetTempFileName( (LPSTR) szTempPath,		// Path Name
							 (LPSTR) "MFT",				// Prefix String (3 chars)
							  (WORD) 0,					// wUnique
							 (LPSTR) szMetaFileName );	// Temporary Filename
			wsprintf( szBuff, "Temp file name is: %s", szMetaFileName );
			ErrorMsg( szBuff );
			for( i=j=0; i<7; i++, j=(j+3)%7 )			// seven points
			{
				pt[i].x = (int)( sin( j*PI2/7 ) * 100 );
				pt[i].y = (int)( cos( j*PI2/7 ) * 100 );
			}
			hdcMeta = CreateMetaFile( (LPSTR) szMetaFileName );
			hPen = CreatePen( PS_NULL, 1, 0L );
			SelectObject( hdcMeta, hPen );
			SelectObject( hdcMeta, GetStockObject( LTGRAY_BRUSH ) );
			Ellipse( hdcMeta, -100, -100, 100, 100 );
			SelectObject( hdcMeta, GetStockObject( DKGRAY_BRUSH ) );
			SetPolyFillMode( hdcMeta, ALTERNATE );
			Polygon( hdcMeta, pt, 7 );
			hMetaFile = CloseMetaFile( hdcMeta );
			DeleteObject( hPen );
			InvalidateRect( hwnd, NULL, TRUE );
			break;

		case WM_SIZE:
			cxWnd = LOWORD( lParam );
			cyWnd = HIWORD( lParam );
			InvalidateRect( hwnd, NULL, TRUE );
			break;

		case WM_PAINT:
			hdc = BeginPaint( hwnd, &ps );
			SetMapMode( hdc, MM_ISOTROPIC );
			SetWindowExtEx( hdc, 1000, 1000, NULL );
			SetViewportExtEx( hdc, cxWnd, cyWnd, NULL );
			for( i=0; i<3; i++ )
			{
				SetWindowOrgEx( hdc, -200-(i*300), -500, NULL );
				PlayMetaFile( hdc, hMetaFile );
				SetWindowOrgEx( hdc, -500, -200-(i*300), NULL );
				PlayMetaFile( hdc, hMetaFile );
			}
			EndPaint( hwnd, &ps );
			break;

		case WM_DESTROY:
			DeleteMetaFile( hMetaFile );
			unlink( szMetaFileName );
			PostQuitMessage(0);
			break;

		default:
			return( DefWindowProc( hwnd, msg, wParam, lParam ) );
	}
	return 0;
}

#include "template.i"

int APIENTRY WinMain( HANDLE hInstance, HANDLE hPrevInstance,
                      LPSTR  lpCmdLine, int    nCmdShow    )
{
	MSG   msg;

	if( ! hPrevInstance )
		if( ! InitApplication( hInstance ) )
			return( FALSE );
	if( ! InitInstance( hInstance, nCmdShow ) )
		return (FALSE);
	while( GetMessage( &msg, NULL, 0, 0 ) )
	{
		TranslateMessage( &msg );
		DispatchMessage( &msg );
	}
	return( msg.wParam );
	UNREFERENCED_PARAMETER( lpCmdLine );
}

