//==============//
//  DDE_DEMO.C  //
//==============//
#include <windows.h>
#include <ddeml.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <time.h>
#include "dde_demo.h"

#define APP_ICON  "DDE_Demo"	// icon name
#define APP_MENU  "DDE_Demo"	// main menu

#ifndef __BORLANDC__
#define random(x)  ( rand() % (int)( x ) )
#endif

#define INTERVAL  5000			// min 5 second intervals

HANDLE	hInst;					// global handle for current instance
HSZ		hszAppName   = 0;		// generic hsz for everything
char	szAppTitle[] = "DDE Application";	// title bar
char	szAppName[]  = "DDE_Demo";			// window class name
int		iConvrs, iInst = 0;

BOOL		fAutomatic = FALSE;
DWORD		idInst = 0;			// DDEML instance object
HCONVLIST	hConvList = 0;		// list of open conversations
HWND		hwnd;				// main window handle
UINT		hFormat,			// handle for transaction format
			LocalStock,			// local data buffer
			DataOut,
			DataIn = 0;
int			xLoc, yLoc, cxText, cyText, cyTitle;

void ErrorMsg( char * Message )
{
	MessageBeep( MB_OK );
	MessageBox( GetFocus(), Message, "Attention", MB_ICONASTERISK | MB_OK );
	return;
}

void ResumeAutomatic( HWND hwnd )
{
	if( ! fAutomatic )
	{
		if( SetTimer( hwnd, 1, random(INTERVAL)+INTERVAL, NULL ) )
		{
			fAutomatic = TRUE;
			MessageBeep( MB_OK );
			InvalidateRect( hwnd, NULL, TRUE );
			UpdateWindow( hwnd );
}	}	}

void PauseAutomatic( HWND hwnd )
{
	if( fAutomatic )
	{
		if( KillTimer( hwnd, 1 ) )
		{
			fAutomatic = FALSE;
			MessageBeep( MB_OK );
			InvalidateRect( hwnd, NULL, TRUE );
			UpdateWindow( hwnd );
}   }   }

VOID PostTransaction( PBYTE pSrc,    // instruction
                      DWORD cbData,  // length of data
                      UINT  xtyp )   // transaction type
{
	HCONV  hConv;
	DWORD  dwResult;
	int    iCheck = 0;

	if( hConvList )
	{
		hConv = DdeQueryNextServer( hConvList, 0 );
		while( hConv )
		{
			iCheck++;
			if( DdeClientTransaction( pSrc, cbData, hConv, hszAppName, hFormat, 
									  xtyp, TIMEOUT_ASYNC, &dwResult ) )
				DdeAbandonTransaction( idInst, hConv, dwResult );
			hConv = DdeQueryNextServer( hConvList, hConv );
		}
		if( iCheck != iConvrs ) // ... connections changed ...
		{
			InvalidateRect( hwnd, NULL, TRUE );
			iConvrs = iCheck;
}	}	}

HDDEDATA CALLBACK DdeCallback( WORD  wType,   WORD     wFmt,
                               HCONV hConv,   HSZ      hszTopic,
                               HSZ   hszItem, HDDEDATA hData,
                               DWORD lData1,  WORD     lData2 )
{
	LPCTSTR	pszExec;
	DWORD	dwSize;

	switch( wType )
	{
		case XTYP_CONNECT:
		   return TRUE;

		case XTYP_ADVREQ:
		case XTYP_REQUEST:
			return( DdeCreateDataHandle( idInst, (PBYTE) &DataOut,
										 sizeof( DataOut ), 0,
										 hszAppName, hFormat, 0 ) );

		case XTYP_ADVSTART:
			return (UINT)( wFmt == hFormat && hszItem == hszAppName );

		case XTYP_ADVDATA:
			if( DdeGetData( hData, (PBYTE) &DataIn, sizeof(DataIn), 0 ) )
				DdeSetUserHandle( hConv, QID_SYNC, DataIn );
			InvalidateRect( hwnd, NULL, TRUE );
			return DDE_FACK;

		case XTYP_EXECUTE:
			pszExec = DdeAccessData( hData, &dwSize );

//=== IMPORTANT = WIN98/95 versions require a four byte correction to the	//
//===             string address returned by the DdeAccessData function;	//
//===             WINNT versions do not require this correction.			//

			if( pszExec[0] <= 0x20 )
				pszExec += 4; 

//=== if you comment out the preceeding test, the global Pause / Resume     //
//=== commands will only work locally -- i.e. will only affect the instance //
//=== where the command is issued ...										//
//=== END CORRECTION =======================================================//

			if( pszExec )
			{
				if( ! stricmp( "PAUSE", pszExec ) )
					PauseAutomatic( hwnd );
				else
				if( ! stricmp( "RESUME", pszExec ) )
					ResumeAutomatic( hwnd );
			}
			break;

		case XTYP_DISCONNECT:
			InvalidateRect( hwnd, NULL, TRUE );
			break;

		case XTYP_REGISTER:
			hConvList = DdeConnectList( idInst, hszItem, hszAppName, 
										hConvList, NULL );
			PostTransaction( NULL, 0, XTYP_ADVSTART );
			UpdateWindow( hwnd );
			return TRUE;
	}
	return( FALSE );
}

LONG APIENTRY WndProc( HWND   hwnd,   UINT message,
                       WPARAM wParam, LONG lParam )
{
	RECT		rc;
	char		szBuff[30];
	int			iLoc;
	PAINTSTRUCT	ps;
	HCONV		hConv;
	CONVINFO	ciData;

	switch (message)
	{
		case WM_CREATE:
			fAutomatic = TRUE;
			SetTimer( hwnd, 1, random(INTERVAL)+INTERVAL, NULL );
			PostMessage( hwnd, WM_SIZE, (WPARAM) SIZE_RESTORED, 0L );
			LocalStock = random(300) + random(300) + random(300);
			break;

		case WM_SIZE:
			if( LOWORD( wParam ) == SIZE_RESTORED )
			{
				SetWindowPos( hwnd, NULL, xLoc, yLoc, 250, 170, SWP_NOZORDER );
				sprintf( szBuff, "Location: #%d", iInst );
				SetWindowText( hwnd, szBuff );
				InvalidateRect( hwnd, NULL, TRUE );
				UpdateWindow( hwnd );
			}
			break;

		case WM_RBUTTONDOWN:  PauseAutomatic( hwnd );   break;

		case WM_LBUTTONDOWN:  ResumeAutomatic( hwnd );  break;

		case WM_TIMER:
			if( random( 2 ) ) 
				LocalStock += random( 100 );
			else
				LocalStock -= min( (UINT) random( 100 ), LocalStock );
			DataOut = ( iInst << 24 ) + LocalStock;
			DdePostAdvise( idInst, hszAppName, hszAppName );
			SetRect( &rc, 0, 0, cxText, cyText );
			InvalidateRect( hwnd, &rc, TRUE );
			UpdateWindow( hwnd );
			break;

		case WM_COMMAND:
			switch( LOWORD( wParam ) )
			{
				case IDG_RESUME:
					PostTransaction( "RESUME", 7, XTYP_EXECUTE );

				case IDL_RESUME:
					ResumeAutomatic( hwnd );
					break;

				case IDG_PAUSE:
					PostTransaction( "PAUSE", 6, XTYP_EXECUTE );

				case IDL_PAUSE:
					PauseAutomatic( hwnd );
					break;
			}
			break;

		case WM_PAINT:		//  PaintDemo( hwnd );    break;
			BeginPaint( hwnd, &ps );
			SetBkMode( ps.hdc, TRANSPARENT );
							// report local stock level
			SetTextColor( ps.hdc, fAutomatic ? 0x000F0FFF: 0x00FFBFBF );
			SetRect( &rc, 0, (iInst-1) * cyText, cxText, iInst * cyText );
			FillRect( ps.hdc, &rc,
				GetStockObject( fAutomatic ? WHITE_BRUSH : GRAY_BRUSH ) );
			sprintf( szBuff, " Local Stock: %5d", LocalStock );
			DrawText( ps.hdc, szBuff, -1, &rc, DT_LEFT | DT_VCENTER );

			SetTextColor( ps.hdc, 0 );            // black text
							// poll other locations and report
			if( hConvList )
			{
				hConv = DdeQueryNextServer( hConvList, 0 );
				while( hConv )
				{
					ciData.cb = sizeof(CONVINFO);
					DdeQueryConvInfo( hConv, QID_SYNC, &ciData );
					iLoc = HIBYTE( HIWORD( ciData.hUser ) );
					if( iLoc > 0 )
					{
						SetRect( &rc, 0, (iLoc-1) * cyText,
								 cxText,  iLoc    * cyText );
						FillRect( ps.hdc, &rc,
							GetStockObject(WHITE_BRUSH) );  // white bkgnd
						sprintf( szBuff, " Location #%d: %5d",
								 iLoc,   LOWORD( ciData.hUser ) );
						DrawText( ps.hdc, szBuff, -1, &rc, DT_LEFT | DT_VCENTER );
					}
					hConv = DdeQueryNextServer( hConvList, hConv );
			}	}
			EndPaint( hwnd, &ps );
			break;

		case WM_CLOSE:
			KillTimer( hwnd, TRUE );
			DdeDisconnectList( hConvList );
			DdeNameService( idInst, 0, 0, DNS_UNREGISTER );
			DdeFreeStringHandle( idInst, hszAppName );
			DdeUninitialize( idInst );
			PostQuitMessage( FALSE );
			break;

		default:
			return( DefWindowProc( hwnd, message, wParam, lParam ) );
	}
	return( FALSE );
}

#include "template.i"

int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    LPSTR     lpCmdLine, INT       nCmdShow )
{
	MSG         msg;
	TEXTMETRIC  metrics;
	HDC         hdc;

	if( ! hPrevInstance )
		if( ! InitApplication( hInstance ) ) 
			return( FALSE );
	if( DdeInitialize( &idInst, (PFNCALLBACK) DdeCallback,
					   APPCMD_FILTERINITS |			// limit (filter) msgs
					   CBF_SKIP_CONNECT_CONFIRMS |	// don't confirm connections
					   CBF_FAIL_SELFCONNECTIONS |	// no self-connection
					   CBF_FAIL_POKES,				// fail XTYP_POKEs
					   0 ) )
		return(FALSE);								// fail if error occurs

	hInst = hInstance;
	hwnd = CreateWindow( szAppName, szAppTitle, WS_OVERLAPPEDWINDOW,
						 CW_USEDEFAULT, CW_USEDEFAULT,
						 CW_USEDEFAULT, CW_USEDEFAULT,
						 NULL, NULL, hInstance, NULL );
	if( ! hwnd )
	{
		DdeUninitialize( idInst );
		return( FALSE );
	}
	if( strlen( lpCmdLine ) ) 
		iInst = atoi( lpCmdLine );
    else 
		iInst = 1;
#ifdef __BORLANDC__
	randomize();
#else
	srand( (unsigned)time( NULL ) );
#endif
	switch( iInst )
	{                 // first one up calls four others
		case 1:	xLoc = 210;		yLoc = 150;
				WinExec( "DDE_DEMO 2", SW_SHOW );
				WinExec( "DDE_DEMO 3", SW_SHOW );
				WinExec( "DDE_DEMO 4", SW_SHOW );
				WinExec( "DDE_DEMO 5", SW_SHOW );	break;
		case 2:	xLoc = 0;		yLoc = 0;			break;
		case 3:	xLoc = 420;		yLoc = 0;			break;
		case 4:	xLoc = 420;		yLoc = 300;			break;
		case 5:	xLoc = 0;		yLoc = 300;			break;
	}
		//=== grab a few measurements for later use
	hdc = GetDC( hwnd );
	GetTextMetrics( hdc, &metrics );
	cyText = metrics.tmHeight + metrics.tmExternalLeading;
	cxText = metrics.tmMaxCharWidth * 20;
	cyTitle = GetSystemMetrics( SM_CYCAPTION );
	ReleaseDC( hwnd, hdc );
		//=== make the application visible
	ShowWindow( hwnd, nCmdShow );
	UpdateWindow( hwnd );
		//=== initialize string handle(s) for later lookups
	hszAppName = DdeCreateStringHandle( idInst, szAppTitle, 0 );
		//=== register format(s)
	hFormat = RegisterClipboardFormat( szAppTitle );
		//=== connect to any other instances which are running
	hConvList = DdeConnectList( idInst, hszAppName, hszAppName, hConvList, NULL );
		//=== register service - causes DDEML to notify other clients
		//=== that a new DDE service is on line
	DdeNameService( idInst, hszAppName, 0, DNS_REGISTER );
		//=== now resume normal message loop
	while( GetMessage( &msg, NULL, 0, 0 ) )
	{
		TranslateMessage( &msg );			// translate virtual key codes
		DispatchMessage( &msg );			// dispatch message to window 
	}
	DestroyWindow( hwnd );					// clean up before exit
	UnregisterClass( szAppTitle, hInstance );
											// don't forget to unregister class
	return( msg.wParam );
	UNREFERENCED_PARAMETER( lpCmdLine );	// prevents unused para warning
}											// message from compiler
